unit CSG;

interface

uses
Windows, Messages, Dialogs, SysUtils, DXGUtils, DirectXGraphics;

const
 COINS = 0;
 FRONT = 1;
 BACK  = -1;
 SPAN  = 2;
 INSIDE = 1;
 OUTSIDE = -1;

type
 Point = TD3DVector;
 Polygon = array of Point;

type
 Triangle = packed record
  a,b,c: TD3DVector;
  norm : TD3DVector;
  dist: single;
end;

type
 MTris = packed record
 Tris: array of Triangle;
end;

type
 TBrush = packed record
 BrushName : string;
 ModelIndex: Integer;
 Loc: TD3DMatrix;
 Rot : TD3DMatrix;
 Scale : TD3DMatrix;
 csgoper: byte;
 MTrform: TD3DMatrix;
end;

procedure CSGCompile(Source : array of TBrush; Data : array of MTris; StartDI: Integer; var Res: MTris);
procedure CSGAddModel(var Res: MTris; Source: array of TBrush; Data: array of MTris; StartDi,bi : Integer);
procedure CSGSubModel(var Res: MTris; Source: array of TBrush; Data: array of MTris; StartDi,bi : Integer);
procedure AddLeft(var res: MTris; Source: array of TBrush; Data: array of MTris; StartDI,bi:Integer);
procedure AddRight(var res: MTris; Source: array of TBrush; Data: array of MTris; StartDI,bi:Integer);
procedure SubLeft(var res: MTris; Source: array of TBrush; Data: array of MTris; StartDI,bi:Integer);
procedure SubRight(var res: MTris; Source: array of TBrush; Data: array of MTris; StartDI,bi:Integer);
procedure DoConvex(var Model: MTris);
procedure InOutSide(var Ins,Outs,Coinc,Codir: MTris; Tris: MTris; Model: MTris);
procedure Split(poly : Triangle; part : Triangle; var front,back : Polygon);
procedure ConvexAdd(var Res: MTris; Model: Mtris);
procedure PolyAdd(var Res: MTris; Poly: Triangle; Model: MTris);
procedure ConvexSub(var Res: MTris; Model: Mtris);
procedure PolySub(var Res: MTris; Poly: Triangle; Model: MTris);
function IsConvex(Model: MTris): boolean;
function TestPoint(Polygon: Triangle; Point : TD3DVector): Integer; // where is Point?
function TestPoly(Poly1,Poly2 : Triangle): Integer;     // where is Poly2?
function IsPolyInfront(Poly1,Poly2 : Triangle): boolean;   // is Poly2 infront of Poly1?
function ModelsIntersect(ModelA, ModelB : MTris): boolean;  // do models intersects?
function TriIntersect(Poly: Triangle; Model: MTris): boolean;

implementation

procedure AddLeft(var res: MTris; Source: array of TBrush; Data: array of MTris; StartDI,bi:Integer);
var
ti,mi: Integer;
mires,mores,mres,mcires,mcdres: MTris;
begin
  setlength(mires.Tris,0);
  setlength(mores.Tris,0);
  setlength(mcires.Tris,0);
  setlength(mcdres.Tris,0);
  setlength(mres.Tris,0);
  for mi:=bi-1 downto 0 do begin
   InOutSide(mires,mores,mcires,mcdres,Res,Data[StartDI+mi]);
   if Source[mi].csgoper=2 then begin
    for ti:=0 to high(mires.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=mires.Tris[ti];
    end;
    for ti:=0 to high(mcdres.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=mcdres.Tris[ti];
    end;
     for ti:=0 to high(mcires.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=mcires.Tris[ti];
    end;
   end else begin
    for ti:=0 to high(mcdres.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=mcdres.Tris[ti];
    end;
   end;
    Res:=mores;
   end;
 for ti:=0 to high(res.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=res.Tris[ti];
    end;
 Res:=mres;
end;

procedure AddRight(var res: MTris; Source: array of TBrush; Data: array of MTris; StartDI,bi:Integer);
var
mi,ti: Integer;
mires,mores,mres,mcires,mcdres: MTris;
begin
  setlength(mires.Tris,0);
  setlength(mores.Tris,0);
  setlength(mcires.Tris,0);
  setlength(mcdres.Tris,0);
  setlength(mres.Tris,0);
  for mi:=bi+1 to high(Source) do begin
   InOutSide(mires,mores,mcires,mcdres,Res,Data[StartDI+mi]);
   if Source[mi].csgoper=1 then begin
    for ti:=0 to high(mcdres.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=mcdres.Tris[ti];
    end;
    for ti:=0 to high(mcires.Tris) do begin
      setlength(mores.Tris,length(mores.Tris)+1);
      mores.Tris[high(mores.Tris)]:=mcires.Tris[ti];
    end;
    end else
    begin
     for ti:=0 to high(mcires.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=mcires.Tris[ti];
    end;
   end;
   Res:=mores;
  end;
 for ti:=0 to high(res.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=res.Tris[ti];
    end;
 Res:=mres;
end;

procedure SubLeft(var res: MTris; Source: array of TBrush; Data: array of MTris; StartDI,bi:Integer);
var
ti,mi: Integer;
mires,mores,mres,mcires,mcdres: MTris;
begin
  setlength(mires.Tris,0);
  setlength(mores.Tris,0);
  setlength(mcires.Tris,0);
  setlength(mcdres.Tris,0);
  setlength(mres.Tris,0);
  for mi:=bi-1 downto 0 do begin
   InOutSide(mires,mores,mcires,mcdres,Res,Data[StartDI+mi]);
    if Source[mi].csgoper=1 then begin
    for ti:=0 to high(mires.Tris) do begin
     setlength(mRes.Tris,length(mRes.Tris)+1);
     mRes.Tris[high(mRes.Tris)]:=mires.Tris[ti];
    end;
    for ti:=0 to high(mcires.Tris) do begin
      setlength(mores.Tris,length(mores.Tris)+1);
      mores.Tris[high(mores.Tris)]:=mcires.Tris[ti];
    end;
   end else begin
    for ti:=0 to high(mcdres.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=mcdres.Tris[ti];
    end;
   end;
   Res:=mores;
  end;
  for ti:=0 to high(mres.Tris) do begin
   mres.Tris[ti].norm:=VectorMul(mres.Tris[ti].norm,D3DVector(-1,-1,-1));
    mres.Tris[ti].dist:=-mres.Tris[ti].dist;
  end;
 Res:=mres;
end;

procedure SubRight(var res: MTris; Source: array of TBrush; Data: array of MTris; StartDI,bi:Integer);
var
mi,ti: Integer;
mires,mores,mres,mcires,mcdres: MTris;
begin
  setlength(mires.Tris,0);
  setlength(mores.Tris,0);
  setlength(mcires.Tris,0);
  setlength(mcdres.Tris,0);
  setlength(mres.Tris,0);
  for mi:=bi+1 to high(Source) do begin
   InOutSide(mires,mores,mcires,mcdres,Res,Data[StartDI+mi]);
   if Source[mi].csgoper=1 then begin
    for ti:=0 to high(mcdres.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=mcdres.Tris[ti];
    end;
    end;
   end;
   Res:=mores;
  end;
  for ti:=0 to high(res.Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=res.Tris[ti];
    end;
 Res:=mres;
end;

procedure CSGAddModel(var Res: MTris; Source: array of TBrush; Data: array of MTris; StartDi,bi : Integer);
var
 ti: integer;
 mres: MTris;
begin
  setlength(mres.Tris,0);
   for ti:=0 to high(Data[StartDI+bi].Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=Data[StartDI+bi].Tris[ti];
    end;
  AddLeft(mres,Source,Data,StartDI,bi);
  AddRight(mres,Source,Data,StartDI,bi);
  for ti:=0 to high(mres.Tris) do begin
      setlength(Res.Tris,length(Res.Tris)+1);
      Res.Tris[high(Res.Tris)]:=mres.Tris[ti];
    end;
end;

procedure CSGSubModel(var Res: MTris; Source: array of TBrush; Data: array of MTris; StartDi,bi : Integer);
var
 ti: integer;
 mres: MTris;
begin
  setlength(mres.Tris,0);
   for ti:=0 to high(Data[StartDI+bi].Tris) do begin
      setlength(mRes.Tris,length(mRes.Tris)+1);
      mRes.Tris[high(mRes.Tris)]:=Data[StartDI+bi].Tris[ti];
    end;
  SubLeft(mres,Source,Data,StartDI,bi);
  SubRight(mres,Source,Data,StartDI,bi);
  for ti:=0 to high(mres.Tris) do begin
      setlength(Res.Tris,length(Res.Tris)+1);
      Res.Tris[high(Res.Tris)]:=mres.Tris[ti];
    end;
end;

procedure CSGCompile(Source : array of TBrush; Data : array of MTris; StartDI: Integer; var Res: MTris);
var
bi: Integer;
begin
 for bi:=StartDI to StartDI+high(Source) do begin
  DoConvex(Data[bi]);
  if not IsConvex(Data[bi]) then ShowMessage(IntToStr(bi)+'Source Brush DoConvex Failure');
 end;
 setlength(Res.Tris,0);
 for bi:=0 to high(Source) do if Source[bi].csgoper=1 then CSGAddModel(Res,Source,Data,StartDI,bi) else CSGSubModel(Res,Source,Data,StartDI,bi);
end;


procedure ConvexAdd(var Res: MTris; Model: MTris);
var
 i: Integer;
 MRes: MTris;
begin
 setlength(MRes.Tris,0);
 for i:=0 to high(Res.Tris) do PolySub(Mres,Res.Tris[i],Model);
 for i:=0 to high(Model.Tris) do PolySub(Mres,Model.Tris[i],Model);
 Res:=MRes;
end;

procedure ConvexSub(var Res: MTris; Model: MTris);
var
 i: Integer;
 MRes: MTris;
begin
 setlength(Mres.Tris,0);
 for i:=0 to high(Res.Tris) do PolySub(Mres,Res.Tris[i],Model);
 for i:=0 to high(Model.Tris) do PolyAdd(Mres,Model.Tris[i],Res);
 Res:=MRes;
end;

procedure PolySub(var Res: MTris; Poly: Triangle; Model: MTris); //adds to Res parts of Poly wich is OUTSIDE of Model
var
 si,z: Integer;
 fr,bk: Polygon;
 at,bt: Triangle;
begin
 for si:=0 to high(Model.Tris) do begin
  z:=TestPoly(Model.Tris[si],Poly);
  case z of
  BACK: begin
         setlength(Res.Tris,length(res.Tris)+1);
         res.Tris[high(res.Tris)]:=Poly;
         exit;
        end;
  COINS: continue;
  FRONT: continue;
  SPAN: begin
        Split(Poly,Model.Tris[si],fr,bk);
     if length(bk)=3 then begin
     at.A:=bk[0];
     at.B:=bk[1];
     at.C:=bk[2];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     setlength(res.Tris,length(res.Tris)+1);
     res.Tris[high(res.Tris)]:=at;
     end else
     begin
     at.A:=bk[0];
     at.B:=bk[1];
     at.C:=bk[2];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     bt.A:=bk[0];
     bt.B:=bk[2];
     bt.C:=bk[3];
     bt.norm:=Poly.norm;
     bt.dist:=Poly.dist;
     setlength(res.Tris,length(res.Tris)+2);
     res.Tris[high(res.Tris)-1]:=at;
     res.Tris[high(res.Tris)]:=bt;
     end;
    if length(fr)=3 then begin
     at.A:=fr[0];
     at.B:=fr[1];
     at.C:=fr[2];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolySub(res,at,Model);
     end else
     begin
     at.A:=fr[0];
     at.B:=fr[1];
     at.C:=fr[2];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolySub(res,at,Model);
     at.A:=fr[0];
     at.B:=fr[2];
     at.C:=fr[3];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolySub(res,at,Model);
     end;
    exit;
   end;
  end;
 end;
end;

procedure PolyCoin(var coin,codir: MTris; Poly: Triangle; Model: MTris); //adds COPLANAR parts of Poly wich is coincident and coplanar to Model surfs into coin and codir arrays
var
 si,z,i,cc,fc,ti: Integer;
 fr,bk: Polygon;
 at,bt,ct: Triangle;
begin
cc:=0;
fc:=0;
 for si:=0 to high(Model.Tris) do begin
  z:=TestPoly(Model.Tris[si],Poly);
  case z of
  BACK: begin continue; end;
  COINS: begin cc:=cc+1; ti:=si; continue; end;
  FRONT: begin fc:=fc+1; continue; end;
  SPAN: begin
   Split(Poly,Model.Tris[si],fr,bk);
    if length(fr)=3 then begin
     at.A:=fr[0];
     at.B:=fr[1];
     at.C:=fr[2];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolyCoin(coin,codir,at,Model);
     end else
     begin
     at.A:=fr[0];
     at.B:=fr[1];
     at.C:=fr[2];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolyCoin(coin,codir,at,Model);
     at.A:=fr[0];
     at.B:=fr[2];
     at.C:=fr[3];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolyCoin(coin,codir,at,Model);
     end;
    exit;
   end;
  end;
 end;
 if (cc<>0) and ((cc+fc)=length(Model.Tris)) then begin
   if (Poly.norm.x=Model.Tris[ti].norm.x) and (Poly.norm.y=Model.Tris[ti].norm.y) and (Poly.norm.z=Model.Tris[ti].norm.z) then begin
         setlength(codir.Tris,length(codir.Tris)+1);
         codir.Tris[high(codir.Tris)]:=Poly;
         exit;
    end;
  if (Poly.norm.x=-Model.Tris[ti].norm.x) and (Poly.norm.y=-Model.Tris[ti].norm.y) and (Poly.norm.z=-Model.Tris[ti].norm.z) then begin
         setlength(coin.Tris,length(coin.Tris)+1);
         coin.Tris[high(coin.Tris)]:=Poly;
         exit;
    end;
  end;
end;


procedure InOutSide(var Ins,Outs,Coinc,Codir: MTris; Tris: MTris; Model: MTris); // Inside,OutSide, Co-Incident and Co-directed polys.
var
i: Integer;
begin
 setlength(Ins.Tris,0);
 setlength(Outs.Tris,0);
 setlength(Coinc.Tris,0);
 setlength(Codir.Tris,0);
 if ModelsIntersect(Tris,Model) then begin
 for i:=0 to high(Tris.Tris) do begin
   PolySub(Outs,Tris.Tris[i],Model);
   PolyAdd(Ins,Tris.Tris[i],Model);
   PolyCoin(Coinc,Codir,Tris.Tris[i],Model);
 end;
 end else
 begin
  for i:=0 to high(Tris.Tris) do begin
  setlength(Outs.Tris,length(Outs.Tris)+1);
  Outs.Tris[high(Outs.Tris)]:=Tris.Tris[i];
end;
 end;
end;

procedure PolyAdd(var Res: MTris; Poly: Triangle; Model: MTris);  //adds to Res part of Poly which is INSIDE of Model
var
 si,cc,z: Integer;
 fr,bk: Polygon;
 at: Triangle;
begin
 cc:=0;
 for si:=0 to high(Model.Tris) do begin
  z:=TestPoly(Model.Tris[si],Poly);
  case z of
    BACK: exit;
    COINS: cc:=cc+1;
    SPAN: begin
    Split(Poly,Model.Tris[si],fr,bk);
    if length(fr)=3 then begin
     at.A:=fr[0];
     at.B:=fr[1];
     at.C:=fr[2];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolyAdd(Res,at,Model);
     end else
     begin
     at.A:=fr[0];
     at.B:=fr[1];
     at.C:=fr[2];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolyAdd(Res,at,Model);
     at.A:=fr[0];
     at.B:=fr[2];
     at.C:=fr[3];
     at.norm:=Poly.norm;
     at.dist:=Poly.dist;
     PolyAdd(Res,at,Model);
     end;
    exit;
    end;
   end;
  end;
  if cc=0 then begin setlength(Res.Tris,length(Res.Tris)+1);
  Res.Tris[high(Res.Tris)]:=Poly;
  end;
end;

procedure DoConvex(var Model: MTris);
var
 i,j: Integer;
begin
 for i:=0 to high(Model.Tris) do
  for j:=0 to high(Model.Tris) do begin
   if (i<>j) and ((IsPolyInfront(Model.Tris[i],Model.Tris[j]))
    and ( not IsPolyInfront(Model.Tris[j],Model.Tris[i]))) then
    begin
   Model.Tris[j].norm:=VectorMul(Model.Tris[j].norm,D3DVector(-1,-1,-1));
   Model.Tris[j].dist:=-Model.Tris[j].dist;
    end;
    if (i<>j) and (( not IsPolyInfront(Model.Tris[i],Model.Tris[j]))
    and ( not IsPolyInfront(Model.Tris[j],Model.Tris[i]))) then
    begin
   Model.Tris[i].norm:=VectorMul(Model.Tris[i].norm,D3DVector(-1,-1,-1));
    Model.Tris[i].dist:=-Model.Tris[i].dist;
   Model.Tris[j].norm:=VectorMul(Model.Tris[j].norm,D3DVector(-1,-1,-1));
    Model.Tris[j].dist:=-Model.Tris[j].dist;
    end;
 end;
end;

function IsConvex(Model: MTris): boolean;
var
 i,j: Integer;
begin
 result:=true;
 for i:=0 to high(Model.Tris) do begin
  for j:=0 to high(Model.Tris) do begin
   if (i<>j) and (not IsPolyInfront(Model.Tris[i],Model.Tris[j])) then begin
   result:=false;
   break;
   end;
   end;
  if result=false then break;
 end;
if result=false then begin
 for i:=0 to high(Model.Tris) do
  for j:=0 to high(Model.Tris) do begin
   if (i<>j) and (IsPolyInfront(Model.Tris[i],Model.Tris[j])) then begin
   result:=false;
   exit;
   end;
 end;
end;
 result:=true;
end;

function IsPolyInfront(Poly1,Poly2 : Triangle): boolean;
var
 a,b,c: Integer;
begin
   a:=TestPoint(Poly1,Poly2.A);
   b:=TestPoint(Poly1,Poly2.B);
   c:=TestPoint(Poly1,Poly2.C);
  if ((A=FRONT) or (A=COINS)) and ((B=FRONT) or (B=COINS)) and ((C=FRONT) or (C=COINS))
   then result:=true else result:=false;
end;

function TestPoint(Polygon: Triangle; Point : TD3DVector): Integer;
var
SideValue: single;
begin
 SideValue:=VectorDotProduct(Polygon.norm,Point);
 SideValue:=SideValue+Polygon.dist;
 if SideValue<-1 then result:=BACK else
  if SideValue>1 then result:=FRONT else result:=COINS;
end;

function TestPoly(Poly1,Poly2 : Triangle): Integer;
var
 np,nn: Integer;
begin
 np:=0;
 nn:=0;
 if (TestPoint(Poly1,Poly2.A)=FRONT) then np:=np+1;
 if (TestPoint(Poly1,Poly2.B)=FRONT) then np:=np+1;
 if (TestPoint(Poly1,Poly2.C)=FRONT) then np:=np+1;
 if (TestPoint(Poly1,Poly2.A)=BACK) then nn:=nn+1;
 if (TestPoint(Poly1,Poly2.B)=BACK) then nn:=nn+1;
 if (TestPoint(Poly1,Poly2.C)=BACK) then nn:=nn+1;
 if (np>0) and (nn=0) then result:=FRONT else if (nn>0) and (np=0) then result:=BACK else if (nn=0) and (np=0) then result:=COINS else result:=SPAN;
end;

procedure Split(poly : Triangle; part : Triangle; var front,back : Polygon);
var
sideA,sideB,sideC: Integer;
dir,p: TD3DVector;
dist, lambda: single;
begin
 sideA := TestPoint(part,poly.A);
 sideB := TestPoint(part,poly.B);
 sideC := TestPoint(part,poly.C);
  if (sideA = 1) then begin
   setlength(front,length(front)+1);
    front[high(front)]:= poly.A;
   if (sideB = -1) then begin
    dir := VectorSub(poly.B,poly.A);
    dist := VectorDotProduct(poly.B,part.norm);
    lambda :=(-part.dist-dist)/VectorDotProduct(dir,part.norm);
    p :=VectorAdd(poly.B,VectorMulS(dir,lambda));
    setlength(front,length(front)+1);
    setlength(back,length(back)+1);
    front[high(front)]:=p;
    back[high(back)]:=p;
    end;
     end
     else
      if (sideA = -1) then begin
      setlength(back,length(back)+1);
      back[high(back)]:= poly.A;
      if (sideB = 1) then begin
       dir:= VectorSub(poly.B,poly.A);
       dist:= VectorDotProduct(poly.B,part.norm);
       lambda:=(-part.dist-dist)/VectorDotProduct(dir,part.norm);
       p:=VectorAdd(poly.B,VectorMulS(dir,lambda));
       setlength(front,length(front)+1);
       setlength(back,length(back)+1);
       front[high(front)]:=p;
       back[high(back)]:=p;
      end;
     end
      else begin
       setlength(front,length(front)+1);
       setlength(back,length(back)+1);
       front[high(front)]:=poly.A;
       back[high(back)]:=poly.A;
      end;
   if (sideB = 1) then begin
   setlength(front,length(front)+1);
   front[high(front)]:= poly.B;
   if (sideC = -1) then begin
    dir := VectorSub(poly.C,poly.B);
    dist := VectorDotProduct(poly.c,part.norm);
    lambda :=(-part.dist-dist)/VectorDotProduct(dir,part.norm);
    p :=VectorAdd(poly.C,VectorMulS(dir,lambda));
    setlength(front,length(front)+1);
    setlength(back,length(back)+1);
    front[high(front)]:=p;
    back[high(back)]:=p;
       end;
   end
      else
      if (sideB = -1) then begin
       setlength(back,length(back)+1);
       back[high(back)]:= poly.B;
         if (sideC = 1) then begin
       dir:= VectorSub(poly.C,poly.B);
       dist:= VectorDotProduct(poly.C,part.norm);
       lambda:=(-part.dist-dist)/VectorDotProduct(dir,part.norm);
       p:=VectorAdd(poly.C,VectorMulS(dir,lambda));
       setlength(front,length(front)+1);
       setlength(back,length(back)+1);
       front[high(front)]:=p;
       back[high(back)]:=p;
      end;
     end
      else begin
       setlength(front,length(front)+1);
       setlength(back,length(back)+1);
       front[high(front)]:=poly.B;
       back[high(back)]:=poly.B;
      end;
   if (sideC = 1) then begin
    setlength(front,length(front)+1);
    front[high(front)]:= poly.C;
   if (sideA = -1) then begin
    dir := VectorSub(poly.A,poly.C);
    dist := VectorDotProduct(poly.A,part.norm);
    lambda :=(-part.dist-dist)/VectorDotProduct(dir,part.norm);
    p :=VectorAdd(poly.A,VectorMulS(dir,lambda));
    setlength(front,length(front)+1);
    setlength(back,length(back)+1);
    front[high(front)]:=p;
    back[high(back)]:=p;
       end;
      end
      else
      if (sideC = -1) then begin
       setlength(back,length(back)+1);
       back[high(back)]:= poly.C;
         if (sideA = 1) then begin
       dir:= VectorSub(poly.A,poly.C);
       dist:= VectorDotProduct(poly.A,part.norm);
       lambda:=(-part.dist-dist)/VectorDotProduct(dir,part.norm);
       p:=VectorAdd(poly.A,VectorMulS(dir,lambda));
       setlength(front,length(front)+1);
       setlength(back,length(back)+1);
       front[high(front)]:=p;
       back[high(back)]:=p;
      end;
     end
      else begin
       setlength(front,length(front)+1);
       setlength(back,length(back)+1);
       front[high(front)]:=poly.C;
       back[high(back)]:=poly.C;
    end;
end;

function TriIntersect(Poly: Triangle; Model: MTris): boolean;
var
 i,s: Integer;
begin
 result:=true;
 for i:=0 to high(Model.Tris) do begin
  s:=TestPoly(Model.Tris[i],Poly);
  if s=BACK then begin result:=false; exit; end;
 end;
end;

function ModelsIntersect(ModelA, ModelB : MTris): boolean;
var
i,j,bc,s: Integer;
begin
result:=true;
 for i:=0 to high(ModelA.Tris) do begin
  bc:=0;
  for j:=0 to high(ModelB.Tris) do
  begin
   s:=TestPoint(ModelA.Tris[i],ModelB.Tris[j].A);
   if s=BACK then bc:=bc+1 else break;
   s:=TestPoint(ModelA.Tris[i],ModelB.Tris[j].B);
   if s=BACK then bc:=bc+1 else break;
   s:=TestPoint(ModelA.Tris[i],ModelB.Tris[j].C);
   if s=BACK then bc:=bc+1 else break;
  end;
  if bc=length(ModelB.Tris)*3 then begin result:=false; break; end;
 end;
  if result=true then begin
  for i:=0 to high(ModelB.Tris) do begin
  bc:=0;
  for j:=0 to high(ModelA.Tris) do
  begin
   s:=TestPoint(ModelB.Tris[i],ModelA.Tris[j].A);
   if s=BACK then bc:=bc+1 else break;
   s:=TestPoint(ModelB.Tris[i],ModelA.Tris[j].B);
   if s=BACK then bc:=bc+1 else break;
   s:=TestPoint(ModelB.Tris[i],ModelA.Tris[j].C);
   if s=BACK then bc:=bc+1 else break;
  end;
  if bc=length(ModelA.Tris)*3 then begin result:=false; break; end;
  end;
 end;
end;
end.
