unit Form_CellEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GR32, GR32_Image, GR32_Layers, ImgList, StdCtrls, Buttons,
  Menus, Mask, JvExMask, JvSpin, ComCtrls, ToolWin, ExtCtrls, bzip2,
  JvComponent, JvBaseDlg, JvProgressDialog, IniFiles, JvComponentBase;

type
  TCellEditor = class(TForm)
    ViewCells: TImage32;
    CellStates: TBitmap32List;
    lCells: TLabel;
    sbX: TScrollBar;
    sbY: TScrollBar;
    ViewMap: TImage32;
    lMap: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    OpenDialog: TOpenDialog;
    View1: TMenuItem;
    PreviewMap1: TMenuItem;
    Edit1: TMenuItem;
    lbLayers: TListBox;
    Label3: TLabel;
    cSelectedOnly: TCheckBox;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    lCurCell: TLabel;
    Label6: TLabel;
    lCurSub: TLabel;
    Label8: TLabel;
    lCurWorld: TLabel;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    lClientOn: TLabel;
    Label12: TLabel;
    lClientWorld: TLabel;
    btnXYToCursor: TButton;
    GroupBox3: TGroupBox;
    Label14: TLabel;
    lx1y1: TLabel;
    btnSelect1: TButton;
    btnSelect2: TButton;
    GroupBox4: TGroupBox;
    ToolBar1: TToolBar;
    tool1111: TToolButton;
    tool1110: TToolButton;
    tool1101: TToolButton;
    tool1011: TToolButton;
    tool0111: TToolButton;
    tool1100: TToolButton;
    tool1010: TToolButton;
    tool1001: TToolButton;
    tool0110: TToolButton;
    tool0001: TToolButton;
    tool1000: TToolButton;
    tool0100: TToolButton;
    tool0101: TToolButton;
    tool0011: TToolButton;
    tool0010: TToolButton;
    tool0000: TToolButton;
    toolZ: TToolButton;
    ImageList1: TImageList;
    New1: TMenuItem;
    N1: TMenuItem;
    Exportconvdat1: TMenuItem;
    N2: TMenuItem;
    Openworkspace1: TMenuItem;
    SaveWorkspace1: TMenuItem;
    N3: TMenuItem;
    Quit1: TMenuItem;
    Selection1: TMenuItem;
    SelectCursorCell1: TMenuItem;
    ShiftZ1: TMenuItem;
    N4: TMenuItem;
    BottomRightPtfromCursor1: TMenuItem;
    CurrentCell1: TMenuItem;
    N5: TMenuItem;
    FillZ1: TMenuItem;
    FillM1: TMenuItem;
    Label1: TLabel;
    lx2y2: TLabel;
    SelectAll1: TMenuItem;
    MapSettings1: TMenuItem;
    lMouseInfo: TLabel;
    tmrClient: TTimer;
    btnClientZtoZCoord: TButton;
    btnFollow: TSpeedButton;
    btnAddLayer: TSpeedButton;
    btnDeleteLayer: TSpeedButton;
    btnRecordZ: TSpeedButton;
    SaveDialog: TSaveDialog;
    ToolButton18: TToolButton;
    edDrawZ: TJvSpinEdit;
    btnTeleport: TButton;
    btnCursorZtoZCoord: TButton;
    toolE: TToolButton;
    Cell1: TMenuItem;
    ExpandZ1: TMenuItem;
    SolidCell1: TMenuItem;
    cOptimaView: TCheckBox;
    Recordz1: TMenuItem;
    ItisWall1: TMenuItem;
    ItisRoom1: TMenuItem;
    ItisHole1: TMenuItem;
    N6: TMenuItem;
    ClearRecordZ1: TMenuItem;
    ZeroSelection1: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    Buffer1: TMenuItem;
    ClearBuffer1: TMenuItem;
    mCopyFromSelection: TMenuItem;
    mPasteToCursor: TMenuItem;
    N9: TMenuItem;
    SaveToFile1: TMenuItem;
    ReadFromFile1: TMenuItem;
    N10: TMenuItem;
    SaveBufferDialog: TSaveDialog;
    OpenBufferDialog: TOpenDialog;
    ShiftXY1: TMenuItem;
    Memo: TMemo;
    btnBuildZone: TSpeedButton;
    cbWidth: TComboBox;
    Label2: TLabel;
    SaveWorkDialog: TSaveDialog;
    OpenWorkDialog: TOpenDialog;
    btnRecordSolid: TSpeedButton;
    btnRecordMark: TSpeedButton;
    ToolButton1: TToolButton;
    btnDrawSolid: TSpeedButton;
    btnDrawMarks: TSpeedButton;
    RebuildNSEW1: TMenuItem;
    RebuildNSEWClose1: TMenuItem;
    btn_CTeleport: TButton;
    Commands1: TMenuItem;
    rmode11: TMenuItem;
    rmode21: TMenuItem;
    rmode91: TMenuItem;
    N11: TMenuItem;
    camerawalkingmodeon1: TMenuItem;
    camerawalkingmodeoff1: TMenuItem;
    N12: TMenuItem;
    geodata1: TMenuItem;
    N13: TMenuItem;
    showActors1: TMenuItem;
    showStaticMeshes1: TMenuItem;
    showTerrain1: TMenuItem;
    showFog1: TMenuItem;
    showSky1: TMenuItem;
    showCoronas1: TMenuItem;
    showParticles1: TMenuItem;
    showTerritory1: TMenuItem;
    ScanFill1: TMenuItem;
    ScanFillHorizontal1: TMenuItem;
    cFromStat: TCheckBox;
    N14: TMenuItem;
    DeleteCellsZRange1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sbXChange(Sender: TObject);
    procedure ViewMapMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ViewMapMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer; Layer: TCustomLayer);
    procedure Open1Click(Sender: TObject);
    procedure PreviewMap1Click(Sender: TObject);
    procedure lbLayersClick(Sender: TObject);
    procedure cSelectedOnlyClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure ViewCellsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure MapSettings1Click(Sender: TObject);
    procedure ViewCellsMouseLeave(Sender: TObject);
    procedure ViewCellsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer; Layer: TCustomLayer);
    procedure tmrClientTimer(Sender: TObject);
    procedure btnClientZtoZCoordClick(Sender: TObject);
    procedure btnXYToCursorClick(Sender: TObject);
    procedure Exportconvdat1Click(Sender: TObject);
    procedure btnTeleportClick(Sender: TObject);
    procedure btnCursorZtoZCoordClick(Sender: TObject);
    procedure ExpandZ1Click(Sender: TObject);
    procedure SolidCell1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ClearRecordZ1Click(Sender: TObject);
    procedure ItisRoom1Click(Sender: TObject);
    procedure ItisWall1Click(Sender: TObject);
    procedure btnAddLayerClick(Sender: TObject);
    procedure btnBuildZoneClick(Sender: TObject);
    procedure SelectCursorCell1Click(Sender: TObject);
    procedure BottomRightPtfromCursor1Click(Sender: TObject);
    procedure ZeroSelection1Click(Sender: TObject);
    procedure mCopyFromSelectionClick(Sender: TObject);
    procedure mPasteToCursorClick(Sender: TObject);
    procedure SaveToFile1Click(Sender: TObject);
    procedure ReadFromFile1Click(Sender: TObject);
    procedure ShiftZ1Click(Sender: TObject);
    procedure ShiftXY1Click(Sender: TObject);
    procedure SaveWorkspace1Click(Sender: TObject);
    procedure Openworkspace1Click(Sender: TObject);
    procedure FillZ1Click(Sender: TObject);
    procedure FillM1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure CurrentCell1Click(Sender: TObject);
    procedure RebuildNSEW1Click(Sender: TObject);
    procedure RebuildNSEWClose1Click(Sender: TObject);
    procedure btn_CTeleportClick(Sender: TObject);
    procedure btnDeleteLayerClick(Sender: TObject);
    procedure showTerritory1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure ScanFillHorizontal1Click(Sender: TObject);
    procedure DeleteCellsZRange1Click(Sender: TObject);
    procedure ProgressShow(Sender: TObject);
    procedure ProgressClose(Sender: TObject);
  private
    FFirstY: Byte;
    FFirstX: Byte;
    FSelectedY: Integer;
    FSelectedX: Integer;
    FSelectedTop: Integer;
    FSelectedLeft: Integer;
    FSelectedRight: Integer;
    FSelectedBottom: Integer;
    function GetOptimaView: Boolean;
    procedure SetFirstX(const Value: Byte);
    procedure SetFirstY(const Value: Byte);
    procedure SetOptimaView(const Value: Boolean);
    procedure SetSelectedX(const Value: Integer);
    procedure SetSelectedY(const Value: Integer);
    procedure SetSelectedBottom(const Value: Integer);
    procedure SetSelectedLeft(const Value: Integer);
    procedure SetSelectedRight(const Value: Integer);
    procedure SetSelectedTop(const Value: Integer);
  public
    TempMap: TBitmap32;
    function StateBitmapIdx(state: Byte): Integer;
    procedure DrawEmptyCells;

    procedure RedrawAll;
    procedure DrawMap;
    procedure DrawCells;

    procedure DrawToCell(x, y: Integer);

    procedure CenterCell(x, y: Integer);
    procedure MakeCellVisible(x, y: Integer);
    function IsCellVisible(x, y: Integer): boolean;

    property FirstX: Byte read FFirstX write SetFirstX;
    property FirstY: Byte read FFirstY write SetFirstY;
    property OptimaView: Boolean read GetOptimaView write SetOptimaView;

    property SelectedX: Integer read FSelectedX write SetSelectedX;
    property SelectedY: Integer read FSelectedY write SetSelectedY;

    property SelectedTop: Integer read FSelectedTop write SetSelectedTop;
    property SelectedBottom: Integer read FSelectedBottom write
      SetSelectedBottom;
    property SelectedLeft: Integer read FSelectedLeft write SetSelectedLeft;
    property SelectedRight: Integer read FSelectedRight write
      SetSelectedRight;
    procedure AdjustSelected;
    function PtSelected(x, y: Integer): boolean;
  end;

var
  CellEditor: TCellEditor;

implementation

uses Form_ViewFull, Unit_GlobalVars, Form_NewGeo, Form_MapSettings,
  Form_ShiftZ, Form_ShiftXY, Form_DeleteZRange, Form_Progress;

{$R *.dfm}

procedure TCellEditor.FormShow(Sender: TObject);
begin
  DrawEmptyCells;
end;

procedure TCellEditor.FormCreate(Sender: TObject);
var
  s: string;
  ini: TIniFile;
begin

  s := 'YOU MAY NOT use this software for any money-making purpose.'#13 +
    'YOU MAY NOT use this software for any unlawful purpose.'#13 +
    'YOU MAY NOT distribute incomplete or altered copies of this Software.'#13 +
    'YOU MAY NOT charge, lease, rent, request donations, or receive payment in any form for copies of this Software.'#13 +
    'YOU MAY NOT charge for any media used to distribute this Software'#13 +
    'YOU MAY NOT modify, decompile, disassemble, or reverse engineer this Software'#13 +
    'Author does not provide any warranty on this software.'#13 +
    'The software is provided "as is". You bear the risk of using it'#13#13 +
    'DO YOU AGREE WITH HUMORDWARF ?';
  if Application.MessageBox(PChar(s), 'Agreement', MB_YESNO + MB_ICONQUESTION) <> IDYES then
    Application.Terminate;


  ColorModelBmp := TBitmap32.Create;

  ini := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
  PlayerInfoBaseStat := ini.ReadInteger('l2StatMemory', 'StatOffset', $001234EC);
  PlayerInfoBasePtr := ini.ReadInteger('l2VarMemory', 'VarPointer', $0012BFC8);
  PlayerInfoBaseAdd := ini.ReadInteger('l2VarMemory', 'VarOffset', $1B0);
  cFromStat.Checked := ini.ReadBool('l2scanner', 'UseStat', True);

  //colormodel
  s := ini.ReadString('interface', 'colormodel', 'colormodel.bmp');
  if FileExists(s) then
  begin
    ColorModelBmp.LoadFromFile(s);
    ColorModel := 1;
  end
  else
  begin
    ColorModel := 0;
  end;

  WorldAddX := ini.ReadInteger('interface', 'worldaddx', 0);
  WorldAddY := ini.ReadInteger('interface', 'worldaddy', 0);
  __MaxLayer := ini.ReadInteger('interface', 'maxlayer', 32);
  SetLength(GeoLayer, __MaxLayer);
  Caption := Caption + ' L' + inttostr(__MaxLayer);

  ini.Free;

  toolZ.Down := True;
  ViewCells.Bitmap.SetSize(512, 512);
  ViewMap.Bitmap.SetSize(256, 256);
  TempMap := TBitmap32.Create;
  TempMap.SetSize(256, 256);
  sbX.Position := 0;
  sbY.Position := 0;
end;

procedure TCellEditor.SetFirstX(const Value: Byte);
begin
  FFirstX := Value;
  if FFirstX > 252 then FFirstX := 252;
end;

procedure TCellEditor.SetFirstY(const Value: Byte);
begin
  FFirstY := Value;
  if FFirstY > 252 then FFirstY := 252;
end;

procedure TCellEditor.RedrawAll;
begin
  //    If Active Then

  begin
    DrawMap;
    DrawCells;
  end;

  if GeoReady then
  begin
    //Cursor labels
    lCurCell.Caption := inttostr(SelectedX div 8) + ' ' + inttostr(SelectedY div 8);
    lCurSub.Caption := inttostr(SelectedX mod 8) + ' ' + inttostr(SelectedY mod 8);
    lCurWorld.Caption := inttostr(_GetWorldX(GeoHead.MX, SelectedX div 8, SelectedX mod 8)) +
      ' ' + inttostr(_GetWorldY(GeoHead.MY, SelectedY div 8, SelectedY mod 8)) +
      ' ' + inttostr(GeoLayer[lbLayers.ItemIndex][SelectedY, SelectedX].z);
    //Cells Top label
    lCells.Caption := 'Cells: (' + inttostr(FirstX) + 'x' + inttostr(FirstY)
      + ')-(' + inttostr(FirstX + 3) + 'x' + inttostr(FirstY + 3) + ')';
    lMap.Caption := 'MAP: ' + inttostr(GeoHead.MX) + '_' + inttostr(GeoHead.MY);
  end
  else
  begin
    //Cursor labels
    lCurCell.Caption := '';
    lCurSub.Caption := '';
    lCurWorld.Caption := '';

    //Cells Top label
    lCells.Caption := '';
    lMap.Caption := 'NOT LOADED';
  end;
end;

procedure TCellEditor.DrawMap;
begin
  ViewMap.Bitmap.Draw(0, 0, TempMap);
  ViewMap.Bitmap.FrameRectS(FFirstX - 1, FFirstY - 1, FFirstX + 5, FFirstY +
    5, clWhite32);
end;

procedure TCellEditor.sbXChange(Sender: TObject);
begin
  //response to scrollbar
  FirstX := sbX.Position;
  FirstY := sbY.Position;
  RedrawAll;
end;

procedure TCellEditor.ViewMapMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
begin
  if ssLeft in Shift then
  begin
    sbX.Position := X;
    sbY.Position := Y;
  end;
end;

procedure TCellEditor.ViewMapMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer; Layer: TCustomLayer);
begin
  if ssLeft in Shift then
  begin
    sbX.Position := X;
    sbY.Position := Y;
  end;
end;

procedure TCellEditor.Open1Click(Sender: TObject);
var
  geoerr: TGeoError;
  k: Integer;
begin
  if OpenDialog.Execute then
  begin
    Screen.Cursor := crHourGlass;
    try
      geoerr := LoadGeoMap(OpenDialog.FileName);
      Progress.Hide;
      if geoerr <> geOK then
      begin
        ClearLayers;
        ShowMessage(GeoErrorToStr(geoerr));
      end
      else
      begin
        ViewFull.Load;
        ViewFull.View.Bitmap.DrawTo(TempMap, TempMap.BoundsRect);

        lbLayers.Clear;
        for k := 0 to _LastLayer do
        begin
          lbLayers.Items.Add('L' + inttostr(k));
        end;
        lbLayers.ItemIndex := _LastLayer;
        //ShowMessage(inttostr(_LastLayer));
        cSelectedOnly.Checked := False;

      end;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
  RedrawAll;
end;

procedure TCellEditor.PreviewMap1Click(Sender: TObject);
begin
  if not GeoReady then
  begin
    ShowMessage('Geo not loaded');
    Exit;
  end;
  ViewFull.ShowModal;
end;

procedure TCellEditor.DrawEmptyCells;
var
  x, y: Integer;
begin
  ViewCells.Bitmap.Clear(clGray32);
  //draw cell images
  for y := 0 to 31 do
    for x := 0 to 31 do
    begin
      ViewCells.Bitmap.Draw(x * 16, y * 16,
        CellStates.Bitmap[StateBitmapIdx($F)]);
      ViewCells.Bitmap.FrameRectS(x * 16, y * 16, x * 16 + 16, y * 16 +
        16, clBlack32);
    end;
  //draw borders
  for y := 0 to 7 do
    for x := 0 to 7 do
      ViewCells.Bitmap.FrameRectS(x * 16 * 8, y * 16 * 8, x * 16 * 8 + 16
        * 8, y * 16 * 8 + 16 * 8, clBlue32);
  ViewCells.Repaint;
end;

function TCellEditor.StateBitmapIdx(state: Byte): Integer;
begin
  //UDLR bits  1=allow  0=restrict
  if state > $F then result := 16 else result := state;
end;


procedure TCellEditor.DrawCells;
var
  ax, ay, x, y, z: Integer;
  c: TColor32;
  LayerNo: Integer;
  ominz, omaxz, odifz: Integer;

begin
  ominz := 32000;
  omaxz := -32000;
  odifz := 0;

  if not GeoReady then
  begin
    DrawEmptyCells;
    exit;
  end;

  LayerNo := lbLayers.ItemIndex;

  if OptimaView then
  begin
    for y := 0 to 31 do
    begin
      for x := 0 to 31 do
      begin
        ax := FirstX * 8 + x;
        ay := FirstY * 8 + y;
        if GeoLayer[LayerNo][ay, ax].m <> $FF then
        begin
          z := GeoLayer[LayerNo][ay, ax].z;
          if z < ominz then ominz := z;
          if z > omaxz then omaxz := z;
        end;
      end;
    end;
    odifz := omaxz - ominz;
    if odifz <= 0 then odifz := 1;
  end;

  //draw cell images
  for y := 0 to 31 do
  begin
    for x := 0 to 31 do
    begin
      ax := FirstX * 8 + x;
      ay := FirstY * 8 + y;
      begin
        if GeoLayer[LayerNo][ay, ax].m <> $FF then
        begin
          if OptimaView then
          begin
            z := GeoLayer[LayerNo][ay, ax].z - ominz;
            if ColorModel = 1 then
            begin
              c := ColorModelBmp.PixelS[z * (ColorModelBmp.Width - 1) div odifz, 0];
            end
            else
            begin
              z := z * 255 div odifz;
              c := Gray32(z);
            end;
          end
          else
          begin
            z := GeoLayer[LayerNo][ay, ax].z - ViewFull.minz;
            if ColorModel = 1 then
            begin
              //c := z * 255 * 255 Div ViewFull.difz;
              c := ColorModelBmp.PixelS[z * (ColorModelBmp.Width - 1) div ViewFull.difz, 0];
            end
            else
            begin
              z := z * 255 div ViewFull.difz;
              c := Gray32(z);
            end;
          end;


          //                    If GeoLayer[LayerNo][ay, ax].m  > $F Then c := clRed32;
          if PtSelected(ax, ay) then
          begin
            c := c and $404000;
            c := c or $000080;
          end;

          ViewCells.Bitmap.FillRectS(x * 16, y * 16, x * 16 + 16, y
            * 16 + 16, c);
          ViewCells.Bitmap.Draw(x * 16, y * 16,
            CellStates.Bitmap[StateBitmapIdx(GeoLayer[LayerNo][ay,
              ax].m and $F)]);
          if GeoLayer[LayerNo][ay, ax].m and $10 > 0 then
          begin
            //recorded
            ViewCells.Bitmap.FillRectS(x * 16 + 7, y * 16 + 7, x * 16
              + 9, y * 16 + 9, clRed32);
          end;

        end
        else
        begin
          ViewCells.Bitmap.FillRectS(x * 16, y * 16, x * 16 + 16, y
            * 16 + 16, clBlack32);
        end;
      end;

      //draw frames
      if (ax = SelectedX) and (ay = SelectedY) then
        c := clLime32
      else
        c := clBlack32;
      ViewCells.Bitmap.FrameRectS(x * 16, y * 16, x * 16 + 16, y * 16 +
        16, c);
    end;
  end;

  //draw borders
  for y := 0 to 7 do
    for x := 0 to 7 do
    begin
      c := clBlue32;
      ViewCells.Bitmap.FrameRectS(x * 16 * 8, y * 16 * 8, x * 16 * 8 + 16
        * 8, y * 16 * 8 + 16 * 8, c);
    end;

  //draw selected solid cell
  x := SelectedX div 8;
  y := SelectedY div 8;
  if (x >= FirstX) and (x <= FirstX + 3) and
    (y >= FirstY) and (y <= FirstY + 3) then
  begin
    x := x - FirstX;
    y := y - FirstY;
    c := clLime32;
    ViewCells.Bitmap.FrameRectS(x * 16 * 8, y * 16 * 8, x * 16 * 8 + 16
      * 8, y * 16 * 8 + 16 * 8, c);
  end;


  ViewCells.Repaint;
end;

procedure TCellEditor.lbLayersClick(Sender: TObject);
begin
  ViewFull.cSelectedOnly.Checked := cSelectedOnly.Checked;
  ViewFull.cbTopLayer.Items.Assign(lbLayers.Items);
  ViewFull.cbTopLayer.ItemIndex := lbLayers.ItemIndex;
  ViewFull.RenderLayers;
  ViewFull.View.Bitmap.DrawTo(TempMap, TempMap.BoundsRect);
  ReDrawAll;
end;

procedure TCellEditor.cSelectedOnlyClick(Sender: TObject);
begin
  lbLayersClick(self);
end;

procedure TCellEditor.New1Click(Sender: TObject);
var
  k: Integer;
begin
  if Application.MessageBox('Start New Geo?', 'Really?', MB_YESNO) <> IDYES
    then exit;
  ClearLayers;
  if NewGeo.ShowModal <> mrOK then
  begin
    ClearLayers;
  end
  else
  begin
    ViewFull.View.Bitmap.DrawTo(TempMap, TempMap.BoundsRect);
    lbLayers.Clear;
    for k := 0 to _LastLayer do
    begin
      lbLayers.Items.Add('L' + inttostr(k));
    end;
    lbLayers.ItemIndex := _LastLayer;
    cSelectedOnly.Checked := False;
  end;

  RedrawAll;
end;

procedure TCellEditor.ViewCellsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
begin
  x := x div 16;
  y := y div 16;
  x := FirstX * 8 + x;
  y := FirstY * 8 + y;
  if x < 0 then exit;
  if y < 0 then exit;
  if x > 2047 then exit;
  if y > 2047 then exit;
  if Shift = [ssLeft] then
  begin
    FSelectedX := x;
    SelectedY := y;
  end;
  if Shift = [ssLeft, ssCtrl] then
  begin
    DrawToCell(x, y);
  end;
end;

procedure TCellEditor.SetSelectedX(const Value: Integer);
begin
  FSelectedX := Value;
  if GeoReady then ReDrawAll;
end;

procedure TCellEditor.SetSelectedY(const Value: Integer);
begin
  FSelectedY := Value;
  if GeoReady then ReDrawAll;
end;

procedure TCellEditor.MapSettings1Click(Sender: TObject);
begin
  if not GeoReady then
  begin
    ShowMessage('Geo not loaded');
    Exit;
  end;
  MapSettings.ShowModal;
end;

procedure TCellEditor.ViewCellsMouseLeave(Sender: TObject);
begin
   lMouseInfo.Caption := '';
end;

procedure TCellEditor.ViewCellsMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  lMouseInfo.Caption := '';
  if not GeoReady then exit;
  if lbLayers.ItemIndex < 0 then exit;

  x := x div 16;
  y := y div 16;
  x := FirstX * 8 + x;
  y := FirstY * 8 + y;
  if x < 0 then exit;
  if y < 0 then exit;
  if x > 2047 then exit;
  if y > 2047 then exit;

  lMouseInfo.Caption := inttostr(_GetWorldX(GeoHead.MX, x div 8, x mod 8)) + ' ' +
    inttostr(_GetWorldY(GeoHead.MY, y div 8, y mod 8)) +
    ' ' +
    inttostr(GeoLayer[lbLayers.ItemIndex][y, x].z);

  if Shift = [ssLeft, ssCtrl] then
  begin
    //draw
    DrawToCell(x, y);
  end;
end;

procedure TCellEditor.tmrClientTimer(Sender: TObject);
var
  x, y: Integer;
  //    z                    : SmallInt;
  z, m: SmallInt;
  cx, cy: Integer;
  sx, sy: Integer;
begin
  //if CellEditor.Enabled = false then exit;
  if ScanClientMemory(cFromStat.Checked) then
  begin
    lClientOn.Caption := 'Yes';
    try
      lClientWorld.Caption := inttostr(ClientPlayerInfoX) + ' ' +
        inttostr(ClientPlayerInfoY) + ' ' +
        inttostr(ClientPlayerInfoZ);
      if btnFollow.Down then
        edDrawZ.Value := ClientPlayerInfoZ;
      if btnRecordZ.Down then
      begin
        _WorldToXY(ClientPlayerInfoX, ClientPlayerInfoY, x, y);
        if isGeoCoord(x, y) then
        begin
          if BtnRecordMark.Down then
            m := $1F
          else
            m := $F;
          z := ClientPlayerInfoZ;

          if btnRecordSolid.Down then
          begin //solid cell
            cx := x div 8;
            cy := y div 8;
            for sy := 0 to 7 do
            begin
              for sx := 0 to 7 do
              begin
                GeoLayer[lbLayers.ItemIndex][8 * cy + sy, 8 * cx
                  + sx].z := z;
                GeoLayer[lbLayers.ItemIndex][8 * cy + sy, 8 * cx
                  + sx].m := m;
              end;
            end;
          end //solid cell
          else
          begin //subcell
            GeoLayer[lbLayers.ItemIndex][y, x].z := z;
            GeoLayer[lbLayers.ItemIndex][y, x].m := m;
          end; //subcell
        end;
      end;
      if btnFollow.Down then
      begin
        btnXYToCursorClick(self);
      end;
    except;
      lClientOn.Caption := 'NO';
    end;
  end
  else
  begin
    lClientOn.Caption := 'NO';
  end;
end;

procedure TCellEditor.btnClientZtoZCoordClick(Sender: TObject);
begin
  edDrawZ.Value := ClientPlayerInfoZ;
end;

procedure TCellEditor.btnXYToCursorClick(Sender: TObject);
var
  x, y: Integer;
begin
  _WorldToXY(ClientPlayerInfoX, ClientPlayerInfoY, x, y);
  if x < 0 then exit;
  FSelectedX := x;
  FSelectedY := y;
  MakeCellVisible(x, y);
end;

procedure TCellEditor.CenterCell(x, y: Integer);
var
  cx, cy: Integer;
begin
  //make cell visible
  cx := x div 8;
  cy := y div 8;
  sbX.Position := cx - 1;
  sbY.Position := cy - 1;
end;

procedure TCellEditor.MakeCellVisible(x, y: Integer);
begin
  if not IsCellVisible(x, y) then CenterCell(x, y);
  RedrawAll;
end;

function TCellEditor.IsCellVisible(x, y: Integer): boolean;
begin
  result := False;
  if x < 0 then exit;
  if y < 0 then exit;
  if x > 2047 then exit;
  if y > 2047 then exit;
  if (x < FirstX * 8) then exit;
  if (y < FirstY * 8) then exit;
  if (x >= (FirstX * 8) + 32) then exit;
  if (y >= (FirstY * 8) + 32) then exit;
  result := True;
end;

procedure TCellEditor.Exportconvdat1Click(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    Screen.Cursor := crHourGlass;
    SaveGeoMapTurbo(SaveDialog.FileName);
    Progress.Hide;
    Screen.Cursor := crDefault;
  end;
end;

procedure TCellEditor.DrawToCell(x, y: Integer);
var
  m: SmallInt;
  z: SmallInt;
  cx, cy: Integer;
  sx, sy: Integer;
begin
  {If toolE.Down Then
  Begin
      If lbLayers.ItemIndex > 0 Then
      Begin
          GeoLayer[lbLayers.ItemIndex][y, x].m := $FF;
          ReDrawAll;
      End;
      exit;
  End;}

  m := $FF;
  if tool0000.Down then m := 0
  else if tool0001.Down then m := 1
  else if tool0010.Down then m := 2
  else if tool0011.Down then m := 3
  else if tool0100.Down then m := 4
  else if tool0101.Down then m := 5
  else if tool0110.Down then m := 6
  else if tool0111.Down then m := 7
  else if tool1000.Down then m := 8
  else if tool1001.Down then m := 9
  else if tool1010.Down then m := 10
  else if tool1011.Down then m := 11
  else if tool1100.Down then m := 12
  else if tool1101.Down then m := 13
  else if tool1110.Down then m := 14
  else if tool1111.Down then m := 15
  else if toolE.Down then m := $FF;

  if lbLayers.ItemIndex = 0 then m := m and $F;

  if btnDrawMarks.Down then
    m := m or $10;

  z := trunc(edDrawZ.Value);

  if btnDrawSolid.Down then
  begin
    cx := x div 8;
    cy := y div 8;
    for sy := 0 to 7 do
    begin
      for sx := 0 to 7 do
      begin
        if toolZ.Down then
          GeoLayer[lbLayers.ItemIndex]
            [8 * cy + sy, 8 * cx + sx].z := z;
        GeoLayer[lbLayers.ItemIndex]
          [8 * cy + sy, 8 * cx + sx].m := m;
      end;
    end;

  end
  else
  begin
    GeoLayer[lbLayers.ItemIndex][y, x].m := m;
    if toolZ.Down then
      GeoLayer[lbLayers.ItemIndex][y, x].z := z;
  end;

  ReDrawAll;
end;

procedure TCellEditor.btnTeleportClick(Sender: TObject);
var
  s: string;
begin
  s := '//teleport ' + lCurWorld.Caption;
  PostKeysToLineAge(s);
end;

procedure TCellEditor.btnCursorZtoZCoordClick(Sender: TObject);
begin
  edDrawZ.Value := GeoLayer[lbLayers.ItemIndex][SelectedY, SelectedX].z;
end;

procedure TCellEditor.ExpandZ1Click(Sender: TObject);
var
  z: SmallInt;
  cx, cy: Integer;
  sx, sy: Integer;
begin
  z := GeoLayer[lbLayers.ItemIndex][SelectedY, SelectedX].z;
  cx := SelectedX div 8;
  cy := SelectedY div 8;
  for sy := 0 to 7 do
  begin
    for sx := 0 to 7 do
    begin
      GeoLayer[lbLayers.ItemIndex][8 * cy + sy, 8 * cx + sx].z := z;
    end;
  end;
  RedrawAll;
end;

function TCellEditor.GetOptimaView: Boolean;
begin
  Result := cOptimaView.Checked;
end;

procedure TCellEditor.SetOptimaView(const Value: Boolean);
begin
  cOptimaView.Checked := Value;
end;

procedure TCellEditor.SolidCell1Click(Sender: TObject);
var
  z, m: SmallInt;
  cx, cy: Integer;
  sx, sy: Integer;
begin
  z := GeoLayer[lbLayers.ItemIndex][SelectedY, SelectedX].z;
  m := GeoLayer[lbLayers.ItemIndex][SelectedY, SelectedX].m;
  cx := SelectedX div 8;
  cy := SelectedY div 8;
  for sy := 0 to 7 do
  begin
    for sx := 0 to 7 do
    begin
      GeoLayer[lbLayers.ItemIndex][8 * cy + sy, 8 * cx + sx].z := z;
      GeoLayer[lbLayers.ItemIndex][8 * cy + sy, 8 * cx + sx].m := m;
    end;
  end;
  RedrawAll;
end;

procedure TCellEditor.SpeedButton1Click(Sender: TObject);
const
  waittime = 500;
var
  i: Integer;
  cx, cy: Integer;
  sx, sy: Integer;
  tx, ty: Integer;
  s: string;
begin
  btnFollow.Down := True;
  btnRecordZ.Down := True;
  cx := SelectedX div 8;
  cy := SelectedY div 8;
  for sy := 0 to 7 do
  begin
    for sx := 0 to 7 do
    begin
      tx := cx * 8 + sx;
      ty := cy * 8 + sy;

      s := '//teleport ' +
        inttostr(_GetWorldX(GeoHead.MX, tx div 8, tx mod 8)) + ' ' +
        inttostr(_GetWorldY(GeoHead.MY, ty div 8, ty mod 8)) + ' 10000';

      PostKeysToLineAge(s);

      for i := 0 to waittime do
      begin
        Application.ProcessMessages;
        sleep(10);
        if (SelectedX = tx) and (SelectedY = ty) then Break;
      end;
    end;
  end;
end;

procedure TCellEditor.ClearRecordZ1Click(Sender: TObject);
var
  x, y, l: Integer;
begin
  if not GeoReady then exit;
  l := lbLayers.ItemIndex;
  for y := 0 to 2047 do
    for x := 0 to 2047 do
    begin
      if GeoLayer[l][y, x].m and $10 > 0 then
        GeoLayer[l][y, x].m :=
          GeoLayer[l][y, x].m and $F;
    end;
end;

procedure TCellEditor.ItisRoom1Click(Sender: TObject);
begin
  FillRecordZ(lbLayers.ItemIndex, SelectedX, SelectedY, 0);
  RedrawAll;
end;

procedure TCellEditor.ItisWall1Click(Sender: TObject);
begin
  FillRecordZ(lbLayers.ItemIndex, SelectedX, SelectedY, 1);
  RedrawAll;
end;

procedure TCellEditor.btnAddLayerClick(Sender: TObject);
begin
  if lbLayers.Count < __MaxLayer - 1 then
  begin
    lbLayers.Items.Add('L' + inttostr(lbLayers.Count));
    _LastLayer := lbLayers.Count - 1;
  end;
end;

procedure TCellEditor.btnBuildZoneClick(Sender: TObject);
begin
  //    btnTeleportClick(self);
  //    Sleep(2000);
  PostKeysToLineAge('///buildzone map=' + inttostr(geoHead.MX) + '_' +
    inttostr(GeoHead.MY) + ' ' + cbWidth.Text, False);
  btnRecordZ.Down := True;
  btnFollow.Down := True;
end;

procedure TCellEditor.SelectCursorCell1Click(Sender: TObject);
begin
  // select top left pt
  FSelectedLeft := SelectedX;
  SelectedTop := SelectedY;
  RedrawAll;
end;

procedure TCellEditor.BottomRightPtfromCursor1Click(Sender: TObject);
begin
  // select bottom right pt
  FSelectedRight := SelectedX;
  SelectedBottom := SelectedY;
  RedrawAll;
end;

procedure TCellEditor.SetSelectedBottom(const Value: Integer);
begin
  if isGeoCoord(Value) then
    FSelectedBottom := Value;
  AdjustSelected;
end;

procedure TCellEditor.SetSelectedLeft(const Value: Integer);
begin
  if isGeoCoord(Value) then
    FSelectedLeft := Value;
  AdjustSelected;
end;

procedure TCellEditor.SetSelectedRight(const Value: Integer);
begin
  if isGeoCoord(Value) then
    FSelectedRight := Value;
  AdjustSelected;
end;

procedure TCellEditor.SetSelectedTop(const Value: Integer);
begin
  if isGeoCoord(Value) then
    FSelectedTop := Value;
  AdjustSelected;
end;

procedure TCellEditor.AdjustSelected;

  procedure Swap(var a, b: Integer);
  var c: Integer;
  begin c := a; a := b; b := c; end;

begin
  if SelectedTop > SelectedBottom then Swap(FSelectedTop, FSelectedBottom);
  if SelectedLeft > SelectedRight then Swap(FSelectedLeft, FSelectedRight);
  //also update captions
  lx1y1.Caption := inttostr(SelectedLeft div 8) + ' ' + inttostr(SelectedTop
    div 8) + ' (' +
    inttostr(SelectedLeft mod 8) + ' ' + inttostr(SelectedTop mod 8) + ')';
  lx2y2.Caption := inttostr(SelectedRight div 8) + ' ' +
    inttostr(SelectedBottom div 8) + ' (' +
    inttostr(SelectedRight mod 8) + ' ' + inttostr(SelectedBottom mod 8) +
    ')';
end;

function TCellEditor.PtSelected(x, y: Integer): boolean;
begin
  if (x >= SelectedLeft) and (x <= SelectedRight) and
    (y >= SelectedTop) and (y <= SelectedBottom) then
    result := True else result := False;
end;

procedure TCellEditor.ZeroSelection1Click(Sender: TObject);
begin
  FSelectedLeft := 0;
  FSelectedRight := 0;
  FSelectedTop := 0;
  SelectedBottom := 0;
  RedrawAll;
end;

procedure TCellEditor.mCopyFromSelectionClick(Sender: TObject);
begin
  GeoLayerToTemp(lbLayers.ItemIndex, SelectedLeft, SelectedTop, SelectedRight, SelectedBottom);
  RedrawAll;
end;

procedure TCellEditor.mPasteToCursorClick(Sender: TObject);
begin
  GeoTempToLayer(lbLayers.ItemIndex, SelectedX, SelectedY);
  RedrawAll;
end;

procedure TCellEditor.SaveToFile1Click(Sender: TObject);
begin
  if not GeoTempTrue then exit;
  // save buffer ro file
  if SaveBufferDialog.Execute then
    SaveTempToFile(SaveBufferDialog.FileName);
end;

procedure TCellEditor.ReadFromFile1Click(Sender: TObject);
begin
  //read buffer from file
  if OpenBufferDialog.Execute then
    LoadTempFromFile(OpenBufferDialog.FileName);
end;

procedure TCellEditor.ShiftZ1Click(Sender: TObject);
var
  x, y, l: Integer;
begin
  if ShiftZ.ShowModal = mrOK then
  begin
    if ShiftZ.DeltaZ.Value = 0 then exit;
    for y := SelectedTop to SelectedBottom do
    begin
      for x := SelectedLeft to SelectedRight do
      begin
        if ShiftZ.AllLayers.Checked then
        begin
          // shift all layers
          for l := 0 to _LastLayer do
          begin
            if GeoLayer[l][y, x].m <> $FF then
            begin
              GeoLayer[l][y, x].z := GeoLayer[l][y, x].z +
                trunc(ShiftZ.DeltaZ.Value);
            end;
          end;
        end
        else
        begin
          // shift current layers
          l := lbLayers.ItemIndex;
          if GeoLayer[l][y, x].m <> $FF then
          begin
            GeoLayer[l][y, x].z := GeoLayer[l][y, x].z +
              trunc(ShiftZ.DeltaZ.Value);
          end;

        end;
      end;
    end;
  end;
  _Normalize0;
  ViewFull.Load;
  ViewFull.View.Bitmap.DrawTo(TempMap, TempMap.BoundsRect);
  RedrawAll;
end;

procedure TCellEditor.ShiftXY1Click(Sender: TObject);
var
  x1, y1, x2, y2, l: Integer;
begin
  if ShiftXY.ShowModal <> mrOK then exit;
  x1 := SelectedLeft + trunc(ShiftXY.DeltaX.Value);
  x2 := SelectedRight + trunc(ShiftXY.DeltaX.Value);
  y1 := SelectedTop + trunc(ShiftXY.DeltaY.Value);
  y2 := SelectedBottom + trunc(ShiftXY.DeltaY.Value);
  if (isGeoCoord(x1, y1) = False) or (isGeoCoord(x2, y2) = False) then
  begin
    ShowMessage('ERROR: Coords out of range');
    exit;
  end;

  if ShiftXY.AllLayers.Checked then
  begin
    for l := 0 to lbLayers.Count - 1 do
    begin
      GeoLayerToTemp(l, SelectedLeft, SelectedTop, SelectedRight,
        SelectedBottom);
      GeoTempToLayer(l, x1, y1, True);
    end;
  end
  else
  begin
    l := lbLayers.ItemIndex;
    GeoLayerToTemp(l, SelectedLeft, SelectedTop, SelectedRight,
      SelectedBottom);
    GeoTempToLayer(l, x1, y1, True);
  end;
  GeoTempTrue := False; //make buffer unavail
  _Normalize0;
  RedrawAll;
end;

procedure TCellEditor.SaveWorkspace1Click(Sender: TObject);
var
  fs: TFileStream;
  cs: TBZCompressionStream;
  h: TWorkspaceHeader;
  i: Integer;
begin
  if not GeoReady then
  begin
    ShowMessage('Nothing to save...');
    Exit;
  end;

  Screen.Cursor := crHourGlass;
  try
    _Normalize0;
    // save workspace
    if SaveWorkDialog.Execute then
    begin
      DeleteFile(SaveWorkDialog.FileName);
      fs := TFileStream.Create(SaveWorkDialog.FileName, fmCreate);
      cs := TBZCompressionStream.Create(bs9, fs);

      FillChar(h, sizeof(h), 0);
      h.ID := WorkSpaceID;
      h.MX := GeoHead.MX;
      h.MY := GeoHead.MY;
      h.ShowWater := True;
      h.FirstX := FirstX;
      h.FirstY := FirstY;
      h.SelectedX := SelectedX;
      h.SelectedY := SelectedY;
      h.LastLayer := lbLayers.Count - 1;
      h.SelectedLayer := lbLayers.ItemIndex;
      h.SelectedOnly := cSelectedOnly.Checked;
      h.OptimaView := cOptimaView.Checked;
      h.SelectedLeft := SelectedLeft;
      h.SelectedTop := SelectedTop;
      h.SelectedRight := SelectedRight;
      h.SelectedBottom := SelectedBottom;
      h.Memo := Memo.Text;

      //write compressed header
      cs.WriteBuffer(h, sizeof(h));

      //write compressed layers

      Progress.Caption := 'Writing GEW...';
      Progress.Max := lbLayers.Count - 1;
      Progress.Position := 0;
      Progress.Show;

      //ShowMessage(inttostr(lbLayers.Count)+'/'+inttostr(Length(GeoLayer)));
      for i := 0 to lbLayers.Count - 1 do
      begin
        Progress.Position := i;
        //Application.ProcessMessages;
        cs.WriteBuffer(GeoLayer[i], sizeof(TGeoLayer));
      end;

      cs.Free;
      fs.Free;
    end;
  finally
    Screen.Cursor := crDefault;
    Progress.Hide;
//    Progress.
  end;
end;

procedure TCellEditor.Openworkspace1Click(Sender: TObject);
var
  fs: TFileStream;
  ds: TBZDeCompressionStream;
  h: TWorkspaceHeader;
  i: Integer;
begin
  try
    // open workspace
    if OpenWorkDialog.Execute then
    begin
      ClearLayers;
      lbLayers.Clear;
      Screen.Cursor := crHourGlass;

      fs := TFileStream.Create(OpenWorkDialog.FileName, fmOpenRead);
      ds := TBZDeCompressionStream.Create(fs);

      FillChar(h, sizeof(h), 0);
      ds.ReadBuffer(h, sizeof(h));
      if h.ID <> WorkSpaceID then
      begin
        ShowMessage(h.ID);
        ShowMessage('ERROR: Invalid File');

      end
      else
      begin
        GeoHead.MX := h.MX;
        GeoHead.MY := h.MY;
        //True := h.ShowWater;
        FirstX := h.FirstX;
        FirstY := h.FirstY;
        SelectedX := h.SelectedX;
        SelectedY := h.SelectedY;

        lbLayers.Clear;
        if h.LastLayer > __MaxLayer then
        begin
          ShowMessage('ERROR: Too many layers (' + inttostr(h.LastLayer) + ')');
          h.LastLayer := __MaxLayer;
        end;
        _LastLayer := h.LastLayer;
        for i := 0 to h.LastLayer do
          lbLayers.Items.Add('L' + inttostr(i));
        lbLayers.ItemIndex := h.SelectedLayer;
        //cSelectedOnly.Checked := h.SelectedOnly;

        cOptimaView.Checked := h.OptimaView;
        SelectedLeft := h.SelectedLeft;
        SelectedTop := h.SelectedTop;
        SelectedRight := h.SelectedRight;
        SelectedBottom := h.SelectedBottom;
        Memo.Text := h.Memo;
      end;

      Progress.Caption := 'Reading GEW...';
      Progress.Max := lbLayers.Count - 1;
      Progress.Position := 0;
      Progress.Show;

      //read layers layers
      for i := 0 to lbLayers.Count - 1 do
      begin
        Progress.Position := i;
        //Application.ProcessMessages;
        ds.ReadBuffer(GeoLayer[i], sizeof(GeoLayer[i]));
      end;

      ds.Free;
      fs.Free;
      GeoReady := True;
    end;
    ViewFull.Load;
    ViewFull.View.Bitmap.DrawTo(TempMap, TempMap.BoundsRect);
    RedrawAll;

  finally
    Screen.Cursor := crDefault;
    Progress.Hide;
  end;
end;

procedure TCellEditor.FillZ1Click(Sender: TObject);
var
  s: string;
  z, l: Integer;
  x, y: Integer;
begin
  s := IntToStr(trunc(edDrawZ.Value));
  if not InputQuery('Z Value', 'New Z for selected area', s) then exit;

  z := StrToIntDef(s, 15001);
  if (z > 15000) or (z < -15000) then
  begin
    ShowMessage('Invalid Value');
    exit;
  end;
  // Fill Z
  l := lbLayers.ItemIndex;
  for y := SelectedTop to SelectedBottom do
    for x := SelectedLeft to SelectedRight do
    begin
      GeoLayer[l][y, x].z := z;
    end;

  _Normalize0;
  ViewFull.Load;
  ViewFull.View.Bitmap.DrawTo(TempMap, TempMap.BoundsRect);
  RedrawAll;
end;

procedure TCellEditor.FillM1Click(Sender: TObject);
var
  s: string;
  z, l: Integer;
  x, y: Integer;
begin
  // Fill M
  s := '15';
  if not InputQuery('M Value', 'New M for selected area', s) then exit;
  z := StrToIntDef(s, 256);
  if (z > 255) or (z < 0) then
  begin
    ShowMessage('Invalid Value');
    exit;
  end;
  // Fill M

  l := lbLayers.ItemIndex;
  for y := SelectedTop to SelectedBottom do
    for x := SelectedLeft to SelectedRight do
    begin
      GeoLayer[l][y, x].m := z;
    end;
  _Normalize0;
  ViewFull.Load;
  ViewFull.View.Bitmap.DrawTo(TempMap, TempMap.BoundsRect);
  RedrawAll;
end;

procedure TCellEditor.SelectAll1Click(Sender: TObject);
begin
  FSelectedLeft := 0;
  FSelectedRight := 2047;
  FSelectedTop := 0;
  SelectedBottom := 2047;
  RedrawAll;
end;

procedure TCellEditor.CurrentCell1Click(Sender: TObject);
var
  x, y: Integer;
begin
  x := SelectedX div 8;
  y := SelectedY div 8;
  x := x * 8;
  y := y * 8;
  FSelectedLeft := x;
  FSelectedTop := y;
  FSelectedRight := x + 7;
  SelectedBottom := y + 7;
  RedrawAll;
end;

procedure TCellEditor.RebuildNSEW1Click(Sender: TObject);
var
  difz: Integer;
  x, y, l: Integer;
  s: string;
begin
  s := '20';
  if not InputQuery('Diff-Z Value', 'Diff-Z for NSEW', s) then exit;
  difz := strtointdef(s, 20);

  l := lbLayers.ItemIndex;
  //tune up movement restrictions
  for y := SelectedTop + 1 to SelectedBottom - 1 do
    for x := SelectedLeft + 1 to SelectedRight - 1 do
    begin
      GeoLayer[l][y, x].m := GeoLayer[l][y, x].m or $F;
      if (x > 0) and (x < 2047) and (y > 0) and (y < 2047) then
      begin
        if (GeoLayer[l][y + 1, x].z - GeoLayer[l][y, x].z > difz) and
          (GeoLayer[l][y + 1, x].m <> $FF) then
          if GeoLayer[l][y, x].m <> $FF then
            GeoLayer[l][y, x].m := GeoLayer[l][y, x].m and 11;
        if (GeoLayer[l][y - 1, x].z - GeoLayer[l][y, x].z > difz) and
          (GeoLayer[l][y - 1, x].m <> $FF) then
          if GeoLayer[l][y, x].m <> $FF then
            GeoLayer[l][y, x].m := GeoLayer[l][y, x].m and 7;
        if (GeoLayer[l][y, x + 1].z - GeoLayer[l][y, x].z > difz) and
          (GeoLayer[l][y, x + 1].m <> $FF) then
          if GeoLayer[l][y, x].m <> $FF then
            GeoLayer[l][y, x].m := GeoLayer[l][y, x].m and 14;
        if (GeoLayer[l][y, x - 1].z - GeoLayer[l][y, x].z > difz) and
          (GeoLayer[l][y, x - 1].m <> $FF) then
          if GeoLayer[l][y, x].m <> $FF then
            GeoLayer[l][y, x].m := GeoLayer[l][y, x].m and 13;
      end;
    end;
end;

procedure TCellEditor.RebuildNSEWClose1Click(Sender: TObject);
var
  difz: Integer;
  x, y, l: Integer;
  s: string;
begin
  s := '20';
  if not InputQuery('Diff-Z Value', 'Diff-Z for NSEW', s) then exit;
  difz := strtointdef(s, 20);

  l := lbLayers.ItemIndex;
  //tune up movement restrictions
  for y := SelectedTop + 1 to SelectedBottom - 1 do
    for x := SelectedLeft + 1 to SelectedRight - 1 do
    begin
      GeoLayer[l][y, x].m := GeoLayer[l][y, x].m or $F;
      if (x > 0) and (x < 2047) and (y > 0) and (y < 2047) then
      begin
        if (GeoLayer[l][y + 1, x].z - GeoLayer[l][y, x].z > difz) or
          (GeoLayer[l][y + 1, x].m = $FF) then
          if GeoLayer[l][y, x].m <> $FF then
            GeoLayer[l][y, x].m := GeoLayer[l][y, x].m and 11;
        if (GeoLayer[l][y - 1, x].z - GeoLayer[l][y, x].z > difz) or
          (GeoLayer[l][y - 1, x].m = $FF) then
          if GeoLayer[l][y, x].m <> $FF then
            GeoLayer[l][y, x].m := GeoLayer[l][y, x].m and 7;
        if (GeoLayer[l][y, x + 1].z - GeoLayer[l][y, x].z > difz) or
          (GeoLayer[l][y, x + 1].m = $FF) then
          if GeoLayer[l][y, x].m <> $FF then
            GeoLayer[l][y, x].m := GeoLayer[l][y, x].m and 14;
        if (GeoLayer[l][y, x - 1].z - GeoLayer[l][y, x].z > difz) or
          (GeoLayer[l][y, x - 1].m = $FF) then
          if GeoLayer[l][y, x].m <> $FF then
            GeoLayer[l][y, x].m := GeoLayer[l][y, x].m and 13;
      end;
    end;
end;

procedure TCellEditor.btn_CTeleportClick(Sender: TObject);
begin
  c_teleport
    (
    _GetWorldX(GeoHead.MX, SelectedX div 8, SelectedX mod 8),
    _GetWorldY(GeoHead.MY, SelectedY div 8, SelectedY mod 8),
    GeoLayer[lbLayers.ItemIndex][SelectedY, SelectedX].z
    );
end;

procedure TCellEditor.btnDeleteLayerClick(Sender: TObject);
begin
  if lbLayers.Items.Count > 1 then
    lbLayers.Items.Delete(lbLayers.Items.Count - 1);
  lbLayers.ItemIndex := lbLayers.Items.Count - 1;
  _LastLayer := lbLayers.ItemIndex;
end;

procedure TCellEditor.showTerritory1Click(Sender: TObject);
var
  s: string;
begin
  s := (Sender as TMenuItem).Caption;
  s := StringReplace(s, '&', '', [rfReplaceAll]);
  PostKeysToLineage(s);
end;

procedure TCellEditor.Quit1Click(Sender: TObject);
begin
  Close;
end;

procedure ScanFillH(l, _x, _y: Integer);
var
  m, i: SmallInt;
  {x,}y: Integer;
  x1, x2: Integer; //left/right X
  z1, z2: SmallInt; //left/right Z
  z, zincr: real; //Z increment
  miny, maxy, minx, maxx: Integer;
begin
  if l < 0 then exit;
  if l > __MaxLayer then exit;
  if _x < 0 then exit;
  if _y < 0 then exit;
  if _x > 2047 then exit;
  if _y > 2047 then exit;

  //horizontal pass
  //find minY
  miny := _y;
  m := 0;
  while miny > 0 do
  begin
    m := GeoLayer[l][miny, _x].m;
    if m <> 255 then Break;
    dec(miny);
  end;
  if m = 255 then exit;


  //find maxY
  maxy := _y;
  while maxy < 2047 do
  begin
    m := GeoLayer[l][maxy, _x].m;
    if m <> 255 then Break;
    inc(maxy);
  end;
  if m = 255 then exit;

  y := miny + 1;

  minx := 2046;
  maxx := 1;

  //for each line...
  while y < maxy do
  begin
    //search left and right X
    x1 := _x;
    while x1 > 0 do
    begin
      m := GeoLayer[l][y, x1].m;
      if m <> 255 then Break;
      dec(x1);
    end;
    if m = 255 then exit;

    x2 := _x;
    while x2 < 2047 do
    begin
      m := GeoLayer[l][y, x2].m;
      if m <> 255 then Break;
      inc(x2);
    end;
    if m = 255 then exit;

    if x1 < minx then minx := x1;
    if x2 > maxx then maxx := x2;

    if m = 255 then exit; //RecordZ not found

    //If x1 = x2 Then x2 := x1 + 1; //oops
    if x1 = x2 then exit;

    //do calcs
    z1 := GeoLayer[l][y, x1].z;
    z2 := GeoLayer[l][y, x2].z;
    z := z1;
    zincr := (z2 - z1) / (x2 - x1);

    //draw Z
    for i := x1 to x2 do
    begin
      GeoLayer[l][y, i].m := $F;
      GeoLayer[l][y, i].z := round(z);
      z := z + zincr;
    end;

    inc(y);
  end;
end;


procedure TCellEditor.ScanFillHorizontal1Click(Sender: TObject);
begin
  ScanFillH(lbLayers.ItemIndex, SelectedX, SelectedY);
  RedrawAll;
end;

procedure TCellEditor.DeleteCellsZRange1Click(Sender: TObject);
var
  minz, maxz, x, y, l: Integer;

  function _InRange(_z: integer): boolean;
  begin
    result := (_z >= minz) and (_z <= maxz);
  end;

begin
  if DeleteZRange.ShowModal <> mrOK then exit;
  minz := Trunc(DeleteZRange.MinZ.Value);
  maxz := Trunc(DeleteZRange.MaxZ.Value);
  if minz >= maxz then
  begin
    ShowMessage(Format('Wrong Z-Values ([%d]>=[%d])', [minz, maxz]));
    exit;
  end;

  if (DeleteZRange.AllLayers.Checked = false) and (lbLayers.ItemIndex = 0) then
  begin
    ShowMessage('Does not work for layer-0');
    exit;
  end;

  Screen.Cursor := crHourGlass;
  for y := SelectedTop to SelectedBottom do
  begin
    for x := SelectedLeft to SelectedRight do
    begin
      if DeleteZRange.AllLayers.Checked then
      begin
        //all layers
        for l := 1 to _LastLayer do
        begin
          if (GeoLayer[l][y, x].m <> $FF) and (_InRange(GeoLayer[l][y, x].z)) then
          begin
            GeoLayer[l][y, x].m := $FF;
          end;
        end;
      end
      else
      begin
        // shift current layers
        l := lbLayers.ItemIndex;
        if (GeoLayer[l][y, x].m <> $FF) and (_InRange(GeoLayer[l][y, x].z)) then
        begin
          GeoLayer[l][y, x].m := $FF;
        end;
      end;
    end;
  end;
  Screen.Cursor := crDefault;

  _Normalize0;
  ViewFull.Load;
  ViewFull.View.Bitmap.DrawTo(TempMap, TempMap.BoundsRect);
  RedrawAll;
end;

procedure TCellEditor.ProgressShow(Sender: TObject);
begin
  CellEditor.Enabled := false;
end;

procedure TCellEditor.ProgressClose(Sender: TObject);
begin
  CellEditor.Enabled := true;
end;

end.

