Unit Form_NewGeo;

Interface

Uses
    Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
    Dialogs, GR32, GR32_Image, GR32_Layers, StdCtrls, Mask, JvExMask, JvSpin, ExtDlgs,
  ExtCtrls;

Type
    TNewGeo = Class(TForm)
        GroupBox1: TGroupBox;
        View1: TImage32;
        btnStep1Browse: TButton;
        GroupBox4: TGroupBox;
        View2: TImage32;
        Label1: TLabel;
        edMinZ: TJvSpinEdit;
        Label2: TLabel;
        edMaxZ: TJvSpinEdit;
        Label18: TLabel;
        edWaterZ: TJvSpinEdit;
        GroupBox2: TGroupBox;
        Label3: TLabel;
        Label4: TLabel;
        Label5: TLabel;
    lCurX: TLabel;
    lCurY: TLabel;
    lCurZ: TLabel;
    btnTeleport: TButton;
        GroupBox3: TGroupBox;
        Label9: TLabel;
    lClientX: TLabel;
        Label11: TLabel;
    lClientY: TLabel;
        Label13: TLabel;
    lClientZ: TLabel;
        Label15: TLabel;
    lClientOn: TLabel;
        Button4: TButton;
        Button5: TButton;
        Button1: TButton;
        GroupBox5: TGroupBox;
        edDiffZ: TJvSpinEdit;
        Button2: TButton;
        Button7: TButton;
        btnSave: TButton;
        btnCancel: TButton;
        GroupBox6: TGroupBox;
        edMapX: TJvSpinEdit;
        edMapY: TJvSpinEdit;
        Label17: TLabel;
        lMousePos: TLabel;
    tmrClient: TTimer;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
        Procedure FormCreate(Sender: TObject);
        Procedure btnStep1BrowseClick(Sender: TObject);
        Procedure btnStep2WizardClick(Sender: TObject);
        Procedure edMinZChange(Sender: TObject);
        Procedure btnViewClick(Sender: TObject);
        Procedure btnCancelClick(Sender: TObject);
        Procedure btnSaveClick(Sender: TObject);
        Procedure Button7Click(Sender: TObject);
        Procedure View2MouseDown(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
        Procedure View2MouseLeave(Sender: TObject);
        Procedure View2MouseMove(Sender: TObject; Shift: TShiftState; X,
            Y: Integer; Layer: TCustomLayer);
    procedure tmrClientTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnTeleportClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    Private
    FSelectedCellY: integer;
    FSelectedCellX: integer;
    procedure SetSelectedCellX(const Value: integer);
    procedure SetSelectedCellY(const Value: integer);
        //        PreviewAmp: integer;
    Public
        Procedure InitBmp(b: TBitmap32);
        Procedure Draw2;

        property SelectedCellX: integer read FSelectedCellX write SetSelectedCellX;
        property SelectedCellY: integer read FSelectedCellY write SetSelectedCellY;
    End;

Var
    NewGeo               : TNewGeo;

Implementation

Uses Form_ZWizard, Form_ViewFull, Unit_GlobalVars;

{$R *.dfm}

Procedure TNewGeo.FormCreate(Sender: TObject);
Begin
    FSelectedCellX := 0;
    FSelectedCellY := 0;
    View1.Bitmap.SetSize(256, 256);
    View1.Bitmap.Clear(clRed32);
    View2.Bitmap.SetSize(512, 512);
    View2.Bitmap.Clear(clRed32);
End;

Procedure TNewGeo.btnStep1BrowseClick(Sender: TObject);
Var
    b                    : TBitmap32;
Begin
    If OpenDialog.Execute Then
    Begin
        b := TBitmap32.Create;
        b.LoadFromFile(OpenDialog.FileName);
        If (b.Width = 256) And (b.Height = 256) Then
        Begin
            InitBmp(b);
            Draw2;
        End
        Else
        Begin
            ShowMessage('ERROR: wrong BMP size');
        End;
        b.Free;
    End;
End;

Procedure TNewGeo.InitBmp(b: TBitmap32);
Var
    minz, maxz, difz     : Integer;
    x, y, z              : Integer;
Begin
    //rotate
//    b.Rotate90();
//    b.FlipVert();

    //search for min, max and dif values
    minz := 255;
    maxz := 0;
    For y := 0 To 255 Do
    Begin
        For x := 0 To 255 Do
        Begin
            //using blue component
            z := BlueComponent(b.Pixel[y, x]);
            If z < minz Then minz := z;
            If z > maxz Then maxz := z;
        End;
    End;

    edMinZ.Value := minz * 76 - 9567.05;
    edMaxZ.Value := maxz * 76 - 9567.05;

    difz := maxz - minz;
    If difz = 0 Then difz := 1;

    //    PreviewAmp := 255 div difz;

        //now scale Z to [0..255]
    For y := 0 To 255 Do
    Begin
        For x := 0 To 255 Do
        Begin
            //using blue component
            z := BlueComponent(b.Pixel[x, y]) - minz;
            z := 255 * z Div difz;
            b.Pixel[x, y] := Gray32(z);
        End;
    End;
    View1.Bitmap.Assign(b);
End;

Procedure TNewGeo.btnStep2WizardClick(Sender: TObject);
Begin
    ZWizard.View.Bitmap.Assign(View1.Bitmap);
    If ZWizard.ShowModal <> mrOK Then exit;
    View2.Bitmap.Assign(ZWizard.View.Bitmap);
End;

Procedure TNewGeo.Draw2;
Var
    x, y, z, w           : Integer;
    c                    : TColor32;
    b                    : TBitmap32;
Begin
    b := TBitmap32.Create;
    b.Assign(View1.Bitmap);
    w := round(255 * (edWaterZ.Value - edMinZ.Value) / (edMaxZ.Value -
        edMinZ.Value));
    For y := 0 To 255 Do
    Begin
        For x := 0 To 255 Do
        Begin
            //using red component
            c := b.Pixel[x, y];
            z := RedComponent(c) { * PreviewAmp};
            c := Gray32(z);
            If z <= w Then c := c Or $40; //add blue
            b.Pixel[x, y] := c;
        End;
    End;
    View2.Bitmap.Draw(View2.Bitmap.BoundsRect, b.BoundsRect, b);
    View2.Bitmap.FrameRectS(2*SelectedCellX-2,2*SelectedCellY-2,2*SelectedCellX+2,2*SelectedCellY+2,clLime32);
    b.Free;
End;

Procedure TNewGeo.edMinZChange(Sender: TObject);
Begin
    Draw2;
End;

Procedure TNewGeo.btnViewClick(Sender: TObject);
Begin
    LoadGeoMap256(trunc(edMapX.Value), trunc(edMapY.Value), View1.Bitmap,
        trunc(edMinZ.Value), trunc(edMaxZ.Value),
        trunc(edDiffZ.Value));
    ViewFull.Load;
    View2.Bitmap.Draw(View2.Bitmap.BoundsRect, ViewFull.View.Bitmap.BoundsRect,
        ViewFull.View.Bitmap);
    //  ViewFull.ShowModal;
End;

Procedure TNewGeo.btnCancelClick(Sender: TObject);
Begin
    Close;
End;

Procedure TNewGeo.btnSaveClick(Sender: TObject);
Begin
    LoadGeoMap256(trunc(edMapX.Value), trunc(edMapY.Value), View1.Bitmap,
        trunc(edMinZ.Value), trunc(edMaxZ.Value),
        trunc(edDiffZ.Value));
    ViewFull.Load;
End;

Procedure TNewGeo.Button7Click(Sender: TObject);
Begin
    LoadGeoMap256(trunc(edMapX.Value), trunc(edMapY.Value), View1.Bitmap,
        trunc(edMinZ.Value), trunc(edMaxZ.Value),
        trunc(edDiffZ.Value));
    ViewFull.Load;
    View2.Bitmap.Draw(View2.Bitmap.BoundsRect, ViewFull.View.Bitmap.BoundsRect,
        ViewFull.View.Bitmap);
    ViewFull.ShowModal;
End;

Procedure TNewGeo.View2MouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Begin
    FSelectedCellX := X div 2;
    SelectedCellY := Y div 2;
    lCurX.Caption := inttostr(_GetWorldX(trunc(edMapX.Value), X div 2));
    lCurY.Caption := inttostr(_GetWorldY(trunc(edMapY.Value), Y div 2));
    lCurZ.Caption := inttostr(GeoLayer[0][Y*4,X*4].z);
End;

Procedure TNewGeo.View2MouseLeave(Sender: TObject);
Begin
    lMousePos.Caption := '';
End;

Procedure TNewGeo.View2MouseMove(Sender: TObject; Shift: TShiftState; X,
    Y: Integer; Layer: TCustomLayer);
Begin
    lMousePos.Caption := 'Cell: ' + inttostr(X Div 2) + ' ' + inttostr(Y Div 2)
        + '    World: ' +
        inttostr(_GetWorldX(trunc(edMapX.Value), X div 2)) + ' ' +
        inttostr(_GetWorldY(trunc(edMapY.Value), Y div 2)) + ' ' +
        inttostr(GeoLayer[0][Y*4,X*4].z);
End;

procedure TNewGeo.SetSelectedCellX(const Value: integer);
begin
  FSelectedCellX := Value;
  if FSelectedCellX<0 then FSelectedCellX:=0
  else if FSelectedCellX>255 then FSelectedCellX:=255;
  Draw2;
end;

procedure TNewGeo.SetSelectedCellY(const Value: integer);
begin
  FSelectedCellY := Value;
  if FSelectedCellY<0 then FSelectedCellY:=0
  else if FSelectedCellY>255 then FSelectedCellY:=255;
  Draw2;
end;

procedure TNewGeo.tmrClientTimer(Sender: TObject);
begin
  if ScanClientMemory then
  begin
    lClientOn.Caption := 'Yes';
    lClientX.Caption := inttostr(ClientPlayerInfoX);
    lClientY.Caption := inttostr(ClientPlayerInfoY);
    lClientZ.Caption := inttostr(ClientPlayerInfoZ);
  end
  else
  begin
    lClientOn.Caption := 'NO';
  end;
end;

procedure TNewGeo.FormShow(Sender: TObject);
begin
  tmrClient.Enabled := true;
end;

procedure TNewGeo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tmrClient.Enabled := false;
end;

procedure TNewGeo.btnTeleportClick(Sender: TObject);
var
  s: string;
begin
  s := '//teleport '+ lCurX.Caption + ' ' + lCurY.Caption;
  ShowMessage(s);
  PostKeysToLineAge(s);
end;

procedure TNewGeo.Button4Click(Sender: TObject);
begin
  edMinZ.Value := ClientPlayerInfoZ;
end;

procedure TNewGeo.Button5Click(Sender: TObject);
begin
  edMaxZ.Value := ClientPlayerInfoZ;
end;

procedure TNewGeo.Button1Click(Sender: TObject);
begin
  edWaterZ.Value := ClientPlayerInfoZ;
end;


End.

