unit MapC1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, DirectXGraphics, DXGUtils, Math,
  Spin, ut_packages, DateUtils, Sub1, CSG;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    ProgressBar1: TProgressBar;
    StatusBar1: TStatusBar;
    Label4: TLabel;
    SpinEdit4: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
   private
       { Private declarations }
   public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Land : array [0..256,0..256] of LandParam;
  cn : Integer;
  inum: Integer;
  package: TUTPackage;
  obj: TUTObject;
  ready : Integer;
  MeshesCount: Integer;
  ActorsCount: Integer;
  Meshes: array of TMesh;
  Actors: array of TActor;
  Amap,Bmap: Integer;
  Landbmp: TBitMap;
  maxi,maxv: Integer;
  GD: array [0..2047,0..2047] of Node;
  GDL: array [0..2047,0..2047] of Node;
  GDU : array [0..2047,0..2047] of Node;
  GDW : array [0..2047,0..2047] of Wnode;
  MT: array of MTris;
  Polygons: array of TPolis;
  Models: array of TModel;
  Brushes: array of TBrush;
  CSGGeom: MTris;
  Area: MTris;


procedure GenAct;
procedure GenBrush;
procedure ReadLand(fname : String);
procedure CacheMap(fname : String);
procedure CalcLand;
procedure CalcArea(var Area: MTris);
procedure CalcMeshes;
procedure IsWalkable;
procedure SaveData(Filename: String);
procedure OptimizeNode(x,y: Integer);
procedure ReadMesh(FileName,MeshName: String; m: Integer);
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 RegisterAllClasses;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
C,D: String;
STDI: Integer;
begin
 if OpenDialog1.Execute then begin
 Button1.Enabled:=False;
 C:=Copy(OpenDialog1.FileName,Pos('.unr',OpenDialog1.FileName)-5,2);
 D:=Copy(OpenDialog1.FileName,Pos('.unr',OpenDialog1.FileName)-2,2);
 Amap:=StrToInt(c);
 Bmap:=StrToInt(d);
 Button1.Caption:=C+'_'+D;
 maxi:=0;
 maxv:=0;
 ReadLand(OpenDialog1.FileName);
 CacheMap(OpenDialog1.FileName);
 SortActors(Actors,MeshesCount,ActorsCount);
 GenAct;
 GenBrush;
 STDI:=ActorsCount-length(Brushes);
 CSGCompile(Brushes,MT,STDI,CSGGeom);
 CalcArea(Area);
 CalcLand;
MT[ActorsCount-length(Brushes)]:=CSGGeom;
ActorsCount:=ActorsCount-length(Brushes)+1;
setlength(Brushes,1);
CalcMeshes;
IsWalkable;
SaveData(IntToStr(Amap)+'_'+IntToStr(Bmap)+'_conv.dat');
 end;
end;

procedure SaveData(Filename: String);
var
f,x,y,sx,sy,df,i,vc,cc,gc: integer;
desc: word;
db: byte;
varbl: boolean;
begin
vc:=0;
cc:=0;
gc:=0;
f:=FileCreate(Filename);
FileSeek(f,18,0);
for x:=0 to 255 do begin
 for y:=0 to 255 do begin
 df:=0;
 varbl:=false;
 for sx:=0 to 7 do for sy:=0 to 7 do begin
 df:=df+length(GD[x*8+sx,y*8+sy]);
 if length(GD[x*8+sx,y*8+sy])>0 then varbl:=true;
 end;
 if df=0 then begin
  desc:=0;
  FileWrite(f,desc,2);
  desc:=word(GDU[x*8,y*8,0]+Form1.SpinEdit4.Value);
  desc:= desc and $fff8;
  FileWrite(f,desc,2);
  desc:=word(GDU[x*8,y*8,0]+Form1.SpinEdit4.Value);
  desc:= desc and $fff8;
  FileWrite(f,desc,2);
  gc:=gc+1;
  cc:=cc+1;
 end else
 if not varbl then begin
  desc:=64;
  FileWrite(f,desc,2);
  for sx:=0 to 7 do for sy:=0 to 7 do begin
   desc:=word((GDU[x*8+sx,y*8+sy,high(GDU[x*8+sx,y*8+sy])]+Form1.SpinEdit4.Value)*2);
   desc:=desc and $FFF0;
   desc:=desc or  GDW[x*8+sx,y*8+sy,high(GDU[x*8+sx,y*8+sy])];
   FileWrite(f,desc,2);
  end;
  cc:=cc+1;
  vc:=vc+64;
 end else
  begin
  desc:=64+df;
  FileWrite(f,desc,2);
  for sx:=0 to 7 do for sy:=0 to 7 do begin
   desc:=length(GDU[x*8+sx,y*8+sy]);
   FileWrite(f,desc,2);
    for i:=0 to high(GDU[x*8+sx,y*8+sy]) do begin
     desc:=word((GDU[x*8+sx,y*8+sy,i]+Form1.SpinEdit4.Value)*2);
     desc:=desc and $FFF0;
     desc:=desc or GDW[x*8+sx,y*8+sy,i];
     FileWrite(f,desc,2);
     vc:=vc+1;
    end;
  end;
 end;
 end;
 Form1.ProgressBar1.Position:=100*x div 255;
 Form1.StatusBar1.SimpleText:='Saving data to file...'+IntToStr(100*x div 255)+'%';
end;
Form1.StatusBar1.SimpleText:='Saving header...';
 FileSeek(f,0,0);
 db:=Amap;
 FileWrite(f,db,1);
 db:=Bmap;
 FileWrite(f,db,1);
 desc:=128;
 FileWrite(f,desc,2);
 desc:=16;
 FileWrite(f,desc,2);
 FileWrite(f,vc,4);
 FileWrite(f,cc,4);
 FileWrite(f,gc,4);
 FileClose(f);
Form1.StatusBar1.SimpleText:='Savind data to file...Done';
Form1.SpinEdit4.Enabled:=False;
Form1.Button1.Caption:='Open';
end;

procedure IsWalkable;
var
am,bm,a,t,x,y,z,l: integer;
Dot,E,W,N,S,p,dir: TD3DVector;
walk,isf: boolean;
cosang,dist,lambda,ai: single;
CurT: Triangle;
CurR: Ray;
diff: single;
MinX,MaxX,MinY,MaxY,MinZ,MaxZ: single;
begin
Form1.ProgressBar1.Position:=0;
for x:=0 to 2047 do begin
 for y:=0 to 2047 do begin
  setlength(GDU[x,y],length(GD[x,y])+length(GDL[x,y]));
  if length(GDU[x,y])=0 then showmessage(IntToStr(x)+' '+IntToStr(y));
  for l:=0 to high(GD[x,y]) do GDU[x,y,l]:=GD[x,y,l];
  if length(GDL[x,y])>0 then GDU[x,y,length(GD[x,y])]:=GDL[x,y,0];
  OptimizeNode(x,y);
  end;
  Form1.ProgressBar1.Position:=100*x div 2047;
  Form1.StatusBar1.SimpleText:='Optimizing and sorting data...'+IntToStr(round(100*x div 2047))+'%';
 end;
 Form1.ProgressBar1.Position:=0;
for x:=0 to 2047 do begin
 for Y:=0 to 2047 do begin
  setlength(GDW[x,y],length(GDU[x,y]));
  FillMemory(@GDW[x,y,0],length(GDW[x,y]),$0F);
 end;
  Form1.ProgressBar1.Position:=100*x div 2047;
  Form1.StatusBar1.SimpleText:='Initializing walkability array...'+IntToStr(round(100*x div 2047))+'%';
 end;
am:=(Amap-20)*32768;
bm:=(Bmap-18)*32768;
Form1.ProgressBar1.Position:=0;
 for a:=0 to ActorsCount-1 do begin
  for t:=0 to high(MT[a].Tris) do begin
    CurT:=MT[a].Tris[t];
     MinX:=CurT.A.X;
     MinY:=CurT.A.Y;
     MaxX:=CurT.A.X;
     MaxY:=CurT.A.Y;
     MinZ:=CurT.A.Z;
     MaxZ:=CurT.a.z;
 if MinX>CurT.B.X then begin MinX:=CurT.B.X end;
 if MinX>CurT.C.X then begin MinX:=CurT.C.X end;
 if MinY>CurT.B.Y then begin MinY:=CurT.B.Y end;
 if MinY>CurT.C.Y then begin MinY:=CurT.C.Y end;
 if MinZ>CurT.B.Z then begin MinZ:=CurT.B.Z end;
 if MinZ>CurT.C.Z then begin MinZ:=CurT.C.Z end;
 if MaxX<CurT.B.X then begin MaxX:=CurT.B.X end;
 if MaxX<CurT.C.X then begin MaxX:=CurT.C.X end;
 if MaxY<CurT.B.Y then begin MaxY:=CurT.B.Y end;
 if MaxY<CurT.C.Y then begin MaxY:=CurT.C.Y end;
 if MaxZ<CurT.B.Z then begin MaxZ:=CurT.B.Z end;
 if MaxZ<CurT.C.Z then begin MaxZ:=CurT.C.Z end;
 if (MinX<am) or (MaxX>(am+32768)) or (MinY<bm) or (MaxY>(bm+32768)) or (MinZ<-16380) or (MaxZ>16380) then continue;
   for x:=trunc(MinX/16)-1 to trunc(MaxX/16)+1 do begin
    for z:=trunc(MinZ/8) to trunc(MaxZ/8) do begin
     CurR.St:=D3DVector(x*16+8,MaxY+8,z*8+1);
     CurR.En:=D3DVector(x*16+8,MinY-8,z*8+1);
      if (RayIntersect(CurR,CurT,p)<>1) then continue;
     for l:=0 to high(GDU[trunc((p.X-am)/16),trunc((p.Y-bm)/16)+1]) do begin
     diff:=p.Z-GDU[trunc((p.X-am)/16),trunc((p.Y-bm)/16)+1,l];
     if (diff<64) and (diff>16) then begin
      if (CurT.norm.z<0.5) and (CurT.norm.z>-0.5) then GDW[trunc((p.X-am)/16),trunc((p.Y-bm)/16)+1,l]:=GDW[trunc((p.X-am)/16),trunc((p.Y-bm)/16)+1,l] and $F7;
       end;
      end;
       for l:=0 to high(GDU[trunc((p.X-am)/16),trunc((p.Y-bm)/16)-1]) do begin
     diff:=p.Z-GDU[trunc((p.X-am)/16),trunc((p.Y-bm)/16)-1,l];
     if (diff<64) and (diff>16) then begin
      if (CurT.norm.z<0.5) and (CurT.norm.z>-0.5) then GDW[trunc((p.X-am)/16),trunc((p.Y-bm)/16)-1,l]:=GDW[trunc((p.X-am)/16),trunc((p.Y-bm)/16)-1,l] and $FB;
       end;
      end;
     end;
    end;
   for y:=trunc(MinY/16)-1 to trunc(MaxY/16)+1 do begin
   for z:=trunc(MinZ/8) to trunc(MaxZ/8) do begin
     CurR.St:=D3DVector(MaxX+8,y*16+8,z*8+1);
     CurR.En:=D3DVector(MinX-8,y*16+8,z*8+1);
       if (RayIntersect(CurR,CurT,p)<>1) then continue;
      for l:=0 to high(GDU[trunc((p.X-am)/16)+1,trunc((p.Y-bm)/16)]) do begin
     diff:=p.Z-GDU[trunc((p.X-am)/16)+1,trunc((p.Y-bm)/16),l];
     if (diff<64) and (diff>16) then begin
      if (CurT.norm.z<0.5) and (CurT.norm.z>-0.5) then GDW[trunc((p.X-am)/16)+1,trunc((p.Y-bm)/16),l]:=GDW[trunc((p.X-am)/16)+1,trunc((p.Y-bm)/16),l] and $FD;
       end;
      end;
      for l:=0 to high(GDU[trunc((p.X-am)/16)-1,trunc((p.Y-bm)/16)]) do begin
     diff:=p.Z-GDU[trunc((p.X-am)/16)-1,trunc((p.Y-bm)/16),l];
    if (diff<64) and (diff>16) then begin
      if (CurT.norm.z<0.5) and (CurT.norm.z>-0.5) then GDW[trunc((p.X-am)/16)-1,trunc((p.Y-bm)/16),l]:=GDW[trunc((p.X-am)/16)-1,trunc((p.Y-bm)/16),l] and $FE;
       end;
      end;
     end;
    end;
   end;
  Form1.ProgressBar1.Position:=100*a div ActorsCount-1;
  Form1.StatusBar1.SimpleText:='Calculating walkability...'+IntToStr(round(100*a div (ActorsCount-1)))+'%';
  end;
  Form1.StatusBar1.SimpleText:='Calculating walkability...Done'
end;

procedure ReadMesh(FileName, MeshName: String; m: Integer);
var
xn,yn,zn : Single;
fin,i,n,k: Integer;
ib: Integer;
l: word;
packag: TUTPackage;
objt: TUTObject;
bbv: byte;
begin
 packag:= TUTPackage.Create;
 packag.Initialize(FileName);
  for n:=0 to packag.ExportedCount-1 do begin
    objt:=packag.Exported[n].UTObject;
    if (packag.Exported[n].UTObjectName=MeshName) and (packag.Exported[n].UTClassName='StaticMesh') then begin
     objt.ReadObject(False);
     objt.RawSaveToFile('obj.tmp');
      Meshes[m].MeshName:=MeshName;
      fin:=FileOpen('obj.tmp',fmOpenRead);
    l:=1;
    while l<>$00 do l:=ReadPrp(fin); //Read Properties
    FileSeek(fin,41,1); // Primitive BB and BS
    i:=ReadIdx(fin); //Material Count
    for ib:=1 to i do FileSeek(fin,14,1); // Materials
    FileRead(fin,Meshes[m].MinX,4);
    FileRead(fin,Meshes[m].MinY,4);
    FileRead(fin,Meshes[m].MinZ,4);
    FileRead(fin,Meshes[m].MaxX,4);
    FileRead(fin,Meshes[m].MaxY,4);
    FileRead(fin,Meshes[m].MaxZ,4);
    FileRead(fin,bbv,1); // Bounding box + Valid
    cn:=ReadIdx(fin); //Vertex Count
    Meshes[m].VertexCount:=cn;
    if cn>maxv then maxv:=cn;
    SetLength(Meshes[m].VertexBuf,cn);
   for i:=0 to cn-1 do begin
  FileRead(fin,Meshes[m].VertexBuf[i].X,4);
  FileRead(fin,Meshes[m].VertexBuf[i].Y,4);
  FileRead(fin,Meshes[m].VertexBuf[i].Z,4);
  FileRead(fin,xn,4);
  FileRead(fin,yn,4);
  FileRead(fin,zn,4);
  Meshes[m].VertexBuf[i].normVector := D3DVector(xn,yn,zn);
  Meshes[m].VertexBuf[i].Color := $00FFFFFF;
   end;
  FileSeek(fin,4,1);
  i:=Readidx(fin);
  while i>$02 do
  begin
  FileSeek(fin,i*4+4,1);
  i:=ReadIdx(fin);
  end;
for  k:=1 to i do begin
  i:=ReadIdx(fin);
  FileSeek(fin,i*8+8,1);
  end;
  inum:=ReadIdx(fin);
  Meshes[m].IndexCount:=inum;
  if inum>maxi then maxi:=inum;
  SetLength(Meshes[m].IndexBuf,inum);
  for i:=0 to inum-1 do FileRead(fin,Meshes[m].IndexBuf[i],2);
  FileClose(fin);
  end;
  end;
  packag.ReleaseAllObjects;
  packag.Destroy;
end;

procedure CacheMap(fname : String);
var
n,i,mpi,k,i2,k2,pf: Integer;
FileName, MeshName: string;
Scale: Single;
Pitch,Yaw,Roll,tmp : String;
ScX,ScY,ScZ : String;
X,Y,Z :String;
MScale,MRotX,MRotY,MRotZ,MTrans: TD3DMatrix;
MRot: TD3DMatrix;
objpoly: ^TUTObjectClassPolys;
objmodel: ^TUTObjectClassModel;
objlevel: ^TUTObjectClassLevel;
Xp,Yp,Zp: String;
obj2: TUTObject;
begin
 Form1.StatusBar1.SimpleText:='Loading objects...';
  package:=TUTPackage.Create;
  package.Initialize(fname);
  MeshesCount:=0;
  ActorsCount:=0;
  SetLength(Meshes,package.ImportedCount);
  Form1.ProgressBar1.Position:=0;
  for n:=0 to package.ImportedCount-1 do begin
   if  package.Imported[n].UTClassName='StaticMesh'  then begin
           MeshName:= package.Imported[n].UTObjectName;
           if Pos('.',package.Imported[n].UTPackageName)<>0 then
           FileName:=Copy(package.Imported[n].UTPackageName,0,Pos('.',package.Imported[n].UTPackageName)-1)
           else FileName:=package.Imported[n].UTPackageName;
           FileName:='../StaticMeshes/'+FileName+'.usx';
           Form1.StatusBar1.SimpleText:='Loading actor '+MeshName+'...';
           ReadMesh(FileName,MeshName,MeshesCount);
           MeshesCount:=MeshesCount+1;
          end;
         Form1.ProgressBar1.Position:=100*n div (package.ImportedCount-1);
       end;
      package.ReleaseAllObjects;
      package.Destroy;
      package:=TUTPackage.Create;
      package.Initialize(fname);
  setlength(Polygons,0);
  Form1.ProgressBar1.Position:=0;
 for n:=0 to package.ExportedCount-1 do  begin
      if  package.Exported[n].UTClassName='Polys'  then begin
      obj:=package.Exported[n].UTObject;
      obj.ReadObject;
      objpoly:=@obj;
      setlength(Polygons,length(Polygons)+1);
      Polygons[high(Polygons)].PolysName:=obj.UTObjectName;
      Polygons[high(Polygons)].PolysCount:=objpoly.PolygonCount;
      setlength(Polygons[high(Polygons)].Polys,0);
      Polygons[high(Polygons)].PolysCount:=0;
      for i:=0 to objpoly.PolygonCount-1 do  begin
     if (objpoly.Polygon[i].ItemName<>package.NameIndex['Sheet']) and (objpoly.Polygon[i].Vertex[0].Z<16000) and (objpoly.Polygon[i].Vertex[0].Z>-16000) then begin
      setlength(Polygons[high(Polygons)].Polys,length(Polygons[high(Polygons)].Polys)+1);
      Polygons[high(Polygons)].Polys[high(Polygons[high(Polygons)].Polys)]:=objpoly.Polygon[i];
      Polygons[high(Polygons)].PolysCount:=Polygons[high(Polygons)].PolysCount+1;
      end;
  end;
     end;
   Form1.ProgressBar1.Position:=100*n div package.ExportedCount-1;
   Form1.StatusBar1.SimpleText:='Loading polygons...'+IntToStr(100*n div (package.ExportedCount-1))+'%';
     end;
  setlength(Models,0);
  Form1.ProgressBar1.Position:=0;
  for n:=0 to package.ExportedCount-1 do  begin
      if  package.Exported[n].UTClassName='Model'  then begin
      obj:=package.Exported[n].UTObject;
      obj.ReadObject;
      objmodel:=@obj;
      setlength(Models,length(Models)+1);
      Models[high(Models)].ModelName:=obj.UTObjectName;
      mpi:=objmodel.Polys;
     for i:=0 to package.ExportedCount-1 do
      if package.Exported[i].exportedindex=mpi-1  then
      for k:=0 to high(Polygons) do
       if  package.Exported[i].UTObjectName=Polygons[k].PolysName then Models[high(Models)].PolysIndex:=k;
      end;
   Form1.ProgressBar1.Position:=100*n div (package.ExportedCount-1);
   Form1.StatusBar1.SimpleText:='Loading models...'+IntToStr(100*n div (package.ExportedCount-1))+'%';
     end;

  setlength(Brushes,0);
 Form1.ProgressBar1.Position:=0;
  objlevel:=nil;
     for n:=0 to package.ExportedCount-1 do  begin
      if package.Exported[n].UtClassName='Level' then begin
        obj:=package.Exported[n].UTObject;
        obj.ReadObject;
        objlevel:=@obj;
      end;
     end;
  if objlevel<>nil then begin
  for n:=0 to objlevel.ActorCount-1 do begin
      k:=objlevel.Actor[n];
    for i:=0 to package.ExportedCount-1 do
        if package.Exported[i].exportedindex=k-1  then begin
          if  package.Exported[i].UTClassName='Brush'  then begin
            obj2:=package.Exported[i].UTobject;
            obj2.Readobject;
            if obj2.Properties.PropertyByName['PolyFlags']<>nil then
            pf:=obj2.Properties.PropertyByName['PolyFlags'].Value else pf:=0;
            pf:=(pf and (PF_Semisolid or PF_NotSolid));
         if (obj2.Properties.PropertyByName['CsgOper']<>nil) and (pf=$00000000) and (obj2.Properties.PropertyByName['Brush']<> nil) and (obj2.Properties.PropertyByName['Location']<> nil)
           then begin
          setlength(Brushes,length(Brushes)+1);
          Brushes[high(Brushes)].BrushName:=obj2.UTobjectName;
         Brushes[high(Brushes)].csgoper:=obj2.Properties.PropertyByName['CsgOper'].Value;
         for i2:=0 to package.ExportedCount-1 do
          if  package.Exported[i2].exportedindex=obj2.Properties.PropertyByName['Brush'].Value-1  then
           for k2:=0 to high(Models) do
           if  package.Exported[i2].UTobjectName=Models[k2].ModelName then begin Brushes[high(Brushes)].ModelIndex:=k2;  end;
       X:=Copy(obj2.Properties.PropertyByName['Location'].Value,4,Pos(',',obj2.Properties.PropertyByName['Location'].Value)-4);
       tmp:=Copy(obj2.Properties.PropertyByName['Location'].Value,Length(X)+7,255);
       Y:=Copy(tmp,0,Pos(',',tmp)-1);
       tmp:=Copy(tmp,Length(Y)+4,255);
       Z:=Copy(tmp,0,Pos(')',tmp)-1);
     if (StrToFloat(Z)>16000) or (StrToFloat(Z)<-16000) then begin setlength(Brushes,length(Brushes)-1); continue; end;
    Xp:='0';
    Yp:='0';
    Zp:='0';
   if (obj2.Properties.PropertyByName['PrePivot']<> nil) then begin
   Xp:=Copy(obj2.Properties.PropertyByName['PrePivot'].Value,4,Pos(',',obj2.Properties.PropertyByName['PrePivot'].Value)-4);
   tmp:=Copy(obj2.Properties.PropertyByName['PrePivot'].Value,Length(Xp)+7,255);
   Yp:=Copy(tmp,0,Pos(',',tmp)-1);
   tmp:=Copy(tmp,Length(Yp)+4,255);
   Zp:=Copy(tmp,0,Pos(')',tmp)-1);
    end;
   SetTranslateMatrix(Brushes[high(Brushes)].Loc,StrToFloat(X)-StrToFloat(Xp),StrToFloat(Y)-StrToFloat(Yp),StrToFloat(Z)-StrToFloat(Zp));
    ScX:='1.0';
    ScY:='1.0';
    ScZ:='1.0';
     SetScaleMatrix(Brushes[high(Brushes)].Scale,StrToFloat(ScX),StrToFloat(ScY),StrToFloat(ScZ));
     Brushes[high(Brushes)].MTrform:=MatrixMul(Brushes[high(Brushes)].Loc,Brushes[high(Brushes)].Scale);
        end;
      end;
   end;
      Form1.StatusBar1.SimpleText:='Loading brushes...'+IntToStr(round(100*n div (objlevel.ActorCount-1)))+'%';
      Form1.ProgressBar1.Position:=100*n div (objlevel.ActorCount-1);
   end;
 end else ShowMessage('FATAL: Level Class not found for map!');
   SetLength(Actors,package.ExportedCount);
   Form1.ProgressBar1.Position:=0;
   for n:=0 to package.ExportedCount-1 do begin
    if package.exported[n].UTClassName='StaticMeshActor'  then begin
       obj:=package.Exported[n].UTObject;
       obj.ReadObject;
       FileName:='';
     if obj.Properties.PropertyByName['StaticMesh'] <> nil then begin
       FileName:=Copy(obj.Properties.PropertyByName['StaticMesh'].DescriptiveValue,0,Pos('.',obj.Properties.PropertyByName['StaticMesh'].DescriptiveValue)-1)+'.usx';
       MeshName:=Copy(obj.Properties.PropertyByName['StaticMesh'].DescriptiveValue,Pos('.',obj.Properties.PropertyByName['StaticMesh'].DescriptiveValue)+1,255);
       MeshName:=Copy(MeshName,Pos('.',MeshName)+1,255);
       Form1.StatusBar1.SimpleText:='Loading static mesh '+MeshName;
     end;
     for i:=0 to MeshesCount-1 do if Meshes[i].MeshName=MeshName then Actors[ActorsCount].MeshIndex:=i;
     if obj.Properties.PropertyByName['Location'] <> nil then begin
       X:=Copy(obj.Properties.PropertyByName['Location'].Value,4,Pos(',',obj.Properties.PropertyByName['Location'].Value)-4);
       tmp:=Copy(obj.Properties.PropertyByName['Location'].Value,Length(X)+7,255);
       Y:=Copy(tmp,0,Pos(',',tmp)-1);
       tmp:=Copy(tmp,Length(Y)+4,255);
       Z:=Copy(tmp,0,Pos(')',tmp)-1);
       Actors[ActorsCount].LocX:=StrToFloat(X);
       Actors[ActorsCount].LocY:=StrToFloat(Y);
       Actors[ActorsCount].LocZ:=StrToFloat(Z);
    end;
    Pitch:='0';
    Yaw:='0';
    Roll:='0';
    if obj.Properties.PropertyByName['Rotation'] <> nil then begin
      Pitch:=Copy(obj.Properties.PropertyByName['Rotation'].Value,8,Pos(',',obj.Properties.PropertyByName['Rotation'].Value)-8);
      tmp:=Copy(obj.Properties.PropertyByName['Rotation'].Value,Length(Pitch)+13,255);
      Yaw:=Copy(tmp,0,Pos(',',tmp)-1);
      tmp:=Copy(tmp,Length(Yaw)+7,255);
      Roll:=Copy(tmp,0,Pos(')',tmp)-1);
    end;
    Actors[ActorsCount].RotR:=StrToInt(Roll);
    Actors[ActorsCount].RotP:=StrToInt(Pitch);
    Actors[ActorsCount].RotY:=StrToInt(Yaw);
    Scale:=1;
    if obj.Properties.PropertyByName['DrawScale'] <> nil then begin
      Scale:=obj.Properties.PropertyByName['DrawScale'].Value;
    end;
    if obj.Properties.PropertyByName['DrawScale3D'] <> nil then begin
       ScX:=Copy(obj.Properties.PropertyByName['DrawScale3D'].Value,4,Pos(',',obj.Properties.PropertyByName['DrawScale3D'].Value)-4);
       tmp:=Copy(obj.Properties.PropertyByName['DrawScale3D'].Value,Length(ScX)+7,255);
       ScY:=Copy(tmp,0,Pos(',',tmp)-1);
       tmp:=Copy(tmp,Length(ScY)+4,255);
       ScZ:=Copy(tmp,0,Pos(')',tmp)-1);
    end;
    if obj.Properties.PropertyByName['DrawScale3D'] <> nil then
     begin
      Actors[ActorsCount].ScaleX:=StrToFloat(ScX);
      Actors[ActorsCount].ScaleY:=StrToFloat(ScY);
      Actors[ActorsCount].ScaleZ:=StrToFloat(ScZ);
     end else begin
      Actors[ActorsCount].ScaleX:=Scale;
            Actors[ActorsCount].ScaleY:=Scale;
                  Actors[ActorsCount].ScaleZ:=Scale;
     end;
     SetScaleMatrix(MScale,Actors[ActorsCount].ScaleX,Actors[ActorsCount].ScaleY,Actors[ActorsCount].ScaleZ);
     SetRotateXMatrix(Actors[ActorsCount].MRotX,2*pi*Actors[ActorsCount].RotR/65536);
     SetRotateYMatrix(Actors[ActorsCount].MRotY,2*pi*Actors[ActorsCount].RotP/65536);
     SetRotateZMatrix(Actors[ActorsCount].MRotZ,2*pi*Actors[ActorsCount].RotY/65536);
    { MRot:=MatrixMul(MRotZ,MatrixMul(MRotY,MRotX));}
     SetTranslateMatrix(Actors[ActorsCount].MLoc,Actors[ActorsCount].LocX,Actors[ActorsCount].LocY,Actors[ActorsCount].LocZ);
     {Actors[ActorsCount].MTrform:=MatrixMul(MTrans,MScale);}
     Actors[ActorsCount].MScale:=MScale;
     ActorsCount:=ActorsCount+1;
    if obj.Properties.PropertyByName['bPendingDelete'] <> nil then begin
     if obj.Properties.PropertyByName['bPendingDelete'].DescriptiveValue = 'True' then ActorsCount:=ActorsCount-1;
     end else
    if obj.Properties.PropertyByName['bDeleteMe'] <> nil then begin
     if obj.Properties.PropertyByName['bDeleteMe'].DescriptiveValue = 'True' then ActorsCount:=ActorsCount-1;
     end else
    if FileName='' then begin ActorsCount:=ActorsCount-1; ShowMessage('Empty Actor Found'); end;
   end;
   Form1.ProgressBar1.Position:=100*n div (package.ExportedCount-1);
  end;
  package.ReleaseAllObjects;
  package.Destroy;
  Form1.StatusBar1.SimpleText:='Loading geometry...Done';
end;

procedure GenAct;
var
ai,t: Integer;
mesh: TMesh;
actor: TActor;
begin
setlength(MT,ActorsCount);
  for ai:=0 to ActorsCount-1 do begin
   actor:=Actors[ai];
   mesh:=Meshes[actor.MeshIndex];
   setlength(MT[ai].Tris, mesh.IndexCount div 3);
     for t:=0 to (mesh.IndexCount div 3)-1 do begin
      MT[ai].Tris[t].a:=D3DVector(mesh.VertexBuf[(mesh.IndexBuf[t*3])].x,mesh.VertexBuf[(mesh.IndexBuf[t*3])].y,mesh.VertexBuf[(mesh.IndexBuf[t*3])].z);
      MT[ai].Tris[t].b:=D3DVector(mesh.VertexBuf[(mesh.IndexBuf[t*3+1])].x,mesh.VertexBuf[(mesh.IndexBuf[t*3+1])].y,mesh.VertexBuf[(mesh.IndexBuf[t*3+1])].z);
      MT[ai].Tris[t].c:=D3DVector(mesh.VertexBuf[(mesh.IndexBuf[t*3+2])].x,mesh.VertexBuf[(mesh.IndexBuf[t*3+2])].y,mesh.VertexBuf[(mesh.IndexBuf[t*3+2])].z);
      MT[ai].Tris[t].a:=MatrixVectorMul(MT[ai].Tris[t].a,actor.MScale);
      MT[ai].Tris[t].b:=MatrixVectorMul(MT[ai].Tris[t].b,actor.MScale);
      MT[ai].Tris[t].c:=MatrixVectorMul(MT[ai].Tris[t].c,actor.MScale);
      MT[ai].Tris[t].a:=MatrixVectorMul(MT[ai].Tris[t].a,actor.MRotX);
      MT[ai].Tris[t].b:=MatrixVectorMul(MT[ai].Tris[t].b,actor.MRotX);
      MT[ai].Tris[t].c:=MatrixVectorMul(MT[ai].Tris[t].c,actor.MRotX);
      MT[ai].Tris[t].a:=MatrixVectorMul(MT[ai].Tris[t].a,actor.MRotY);
      MT[ai].Tris[t].b:=MatrixVectorMul(MT[ai].Tris[t].b,actor.MRotY);
      MT[ai].Tris[t].c:=MatrixVectorMul(MT[ai].Tris[t].c,actor.MRotY);
      MT[ai].Tris[t].a:=MatrixVectorMul(MT[ai].Tris[t].a,actor.MRotZ);
      MT[ai].Tris[t].b:=MatrixVectorMul(MT[ai].Tris[t].b,actor.MRotZ);
      MT[ai].Tris[t].c:=MatrixVectorMul(MT[ai].Tris[t].c,actor.MRotZ);
      MT[ai].Tris[t].a:=MatrixVectorMul(MT[ai].Tris[t].a,actor.MLoc);
      MT[ai].Tris[t].b:=MatrixVectorMul(MT[ai].Tris[t].b,actor.MLoc);
      MT[ai].Tris[t].c:=MatrixVectorMul(MT[ai].Tris[t].c,actor.MLoc);
      MT[ai].Tris[t].norm:=VectorCrossProduct(VectorSub(MT[ai].Tris[t].B,MT[ai].Tris[t].A),VectorSub(MT[ai].Tris[t].C,MT[ai].Tris[t].A));
      MT[ai].Tris[t].norm:=VectorNormalize(MT[ai].Tris[t].norm);
      MT[ai].Tris[t].dist:=-VectorDotProduct(MT[ai].Tris[t].norm,MT[ai].Tris[t].A);
     end;
     Form1.ProgressBar1.Position:=100*ai div (ActorsCount-1);
  Form1.StatusBar1.SimpleText:='Generating actors...'+IntToStr(round(100*ai div (ActorsCount-1)))+'%';
 end;
end;

procedure GenBrush;
var
bi,pi,vi: Integer;
First: TD3DVector;
begin
 for bi:=0 to high(Brushes) do
  begin
     ActorsCount:=ActorsCount+1;
      setlength(MT,length(MT)+1);
       for pi:=0 to Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].PolysCount-1 do begin
         First:=D3DVector(Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[0].X,Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[0].Y,Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[0].Z);
        for vi:=1 to high(Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex)-1 do
         begin
           setlength(MT[ActorsCount-1].Tris,length(MT[ActorsCount-1].Tris)+1);
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].A:=First;
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].B:=D3DVector(Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[vi].X,Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[vi].Y,Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[vi].Z);
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].C:=D3DVector(Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[vi+1].X,Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[vi+1].Y,Polygons[Models[Brushes[bi].ModelIndex].PolysIndex].Polys[pi].Vertex[vi+1].Z);
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].A:=MatrixVectorMul(MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].A,Brushes[bi].MTrform);
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].B:=MatrixVectorMul(MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].B,Brushes[bi].MTrform);
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].C:=MatrixVectorMul(MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].C,Brushes[bi].MTrform);
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].norm:=VectorCrossProduct(VectorSub(MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].B,MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].A),VectorSub(MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].C,MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].A));
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].norm:=VectorNormalize(MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].norm);
           MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].dist:=-VectorDotProduct(MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].norm,MT[ActorsCount-1].Tris[high(MT[ActorsCount-1].Tris)].A);
         end;
       end;
        Form1.ProgressBar1.Position:=100*bi div high(Brushes);
        Form1.StatusBar1.SimpleText:='Generating brushes...'+IntToStr(round(100*bi div high(Brushes)))+'%';
    end;
end;

procedure CalcMeshes;
var
 am,bm: Integer;
 p: TD3DVector;
 CurR: Ray;
 CurT: Triangle;
 a,t,x,y: integer;
 MinX,MinY,MaxX,MaxY : single;
 cosang,dist,lambda,ai: single;
 dir: TD3DVector;
begin
am:=(Amap-20)*32768;
bm:=(Bmap-18)*32768;
Form1.ProgressBar1.Position:=0;
 for a:=0 to ActorsCount-1 do begin
   for t:=0 to high(MT[a].Tris) do begin
    CurT:=MT[a].Tris[t];
     CurT.norm:=VectorCrossProduct(VectorSub(CurT.B,CurT.A),VectorSub(CurT.C,CurT.A));
     CurT.norm:=VectorNormalize(CurT.norm);
     CurT.dist:=-VectorDotProduct(CurT.norm,CurT.A);
     MinX:=CurT.A.X;
     MinY:=CurT.A.Y;
     MaxX:=CurT.A.X;
     MaxY:=CurT.A.Y;
 if MinX>CurT.B.X then begin MinX:=CurT.B.X end;
 if MinX>CurT.C.X then begin MinX:=CurT.C.X end;
 if MinY>CurT.B.Y then begin MinY:=CurT.B.Y end;
 if MinY>CurT.C.Y then begin MinY:=CurT.C.Y end;
 if MaxX<CurT.B.X then begin MaxX:=CurT.B.X end;
 if MaxX<CurT.C.X then begin MaxX:=CurT.C.X end;
 if MaxY<CurT.B.Y then begin MaxY:=CurT.B.Y end;
 if MaxY<CurT.C.Y then begin MaxY:=CurT.C.Y end;
 if (MinX<am) or (MaxX>(am+32768)) or (MinY<bm) or (MaxY>(bm+32768)) then continue;
  for y:=trunc(MinY/16)-1 to trunc(MaxY/16)+1 do begin
   for x:=trunc(MinX/16)-1 to trunc(MaxX/16)+1 do begin
    CurR.St:=D3DVector(x*16+8,y*16+8,16384);
    CurR.En:=D3DVector(x*16+8,y*16+8,-16384);
    { dir:=VectorSub(CurR.En,CurR.St);
      cosang:=VectorDotProduct(dir,CurT.norm);
     if (cosang>-EPSILON) and (cosang<EPSILON) then continue;
     dist:= VectorDotProduct(CurR.St,CurT.norm);
     lambda:=(-CurT.dist-dist)/cosang;
     if (lambda<0) or (lambda>1) then continue;
     p:=VectorAdd(CurR.St,VectorMulS(dir,lambda));
     if CurT.norm.z>0 then begin
        ai:=(p.Y-CurT.A.Y)*(CurT.B.X-CurT.A.X)-(p.X-CurT.A.X)*(CurT.B.Y-CurT.A.Y);
        if ai<0 then continue;
        ai:=(p.Y-CurT.B.Y)*(CurT.C.X-CurT.B.X)-(p.X-CurT.B.X)*(CurT.C.Y-CurT.B.Y);
        if ai<0 then continue;
        ai:=(p.Y-CurT.C.Y)*(CurT.A.X-CurT.C.X)-(p.X-CurT.C.X)*(CurT.A.Y-CurT.C.Y);
        if ai<0 then continue;
       end else begin
        ai:=(p.Y-CurT.A.Y)*(CurT.B.X-CurT.A.X)-(p.X-CurT.A.X)*(CurT.B.Y-CurT.A.Y);
        if ai>0 then continue;
        ai:=(p.Y-CurT.B.Y)*(CurT.C.X-CurT.B.X)-(p.X-CurT.B.X)*(CurT.C.Y-CurT.B.Y);
        if ai>0 then continue;
        ai:=(p.Y-CurT.C.Y)*(CurT.A.X-CurT.C.X)-(p.X-CurT.C.X)*(CurT.A.Y-CurT.C.Y);
        if ai>0 then continue;
       end;}
     if (RayIntersect(CurR,CurT,p)<>1) then continue;
     if (((trunc(p.X)-am) div 16)>=0) and (((trunc(p.X)-am) div 16)<=2047) and (((trunc(p.Y)-bm) div 16)>=0) and (((trunc(p.Y)-bm) div 16)<=2047) then begin
      setlength(GD[(trunc(p.X)-am) div 16,(trunc(p.Y)-bm) div 16],length(GD[(trunc(p.X)-am) div 16,(trunc(p.Y)-bm) div 16])+1);
      GD[(trunc(p.X)-am) div 16,(trunc(p.Y)-bm) div 16,length(GD[(trunc(p.X)-am) div 16,(trunc(p.Y)-bm) div 16])-1]:= round (p.Z);
     end;
     end; //x
    end; //y
   end; //tris
  Form1.ProgressBar1.Position:=100*a div (ActorsCount-1);
   Form1.StatusBar1.SimpleText:='Calculating geometry...'+IntToStr(100*a div (ActorsCount-1))+'%';
end;
 Form1.StatusBar1.SimpleText:='Calculating geometry...Done'
end;

procedure ReadLand;
const
 Restit = 9567.05;
var
n,i,j: Integer;
tex: ^TUTObjectClassTexture;
begin
Form1.StatusBar1.SimpleText:='Loading terrain...';
ZeroMemory(@Land,66049* SizeOf(LandParam));
 package:= TUTPackage.Create;
 package.Initialize('../Textures/T_'+IntToStr(Amap)+'_'+IntToStr(Bmap)+'.utx');
  for n:=0 to package.ExportedCount-1 do begin
     if package.exported[n].UTObjectName=IntToStr(Amap)+'_'+IntToStr(Bmap)  then begin
      obj:=package.Exported[n].UTObject;
      obj.ReadObject;
      tex:=@obj;
      for i:= 0 to 255 do
  for j:= 0 to 255 do begin
   Land[j,i].h := (tex.Lan[j,i]/256) * 76 - Restit;
 end;
     end;
   end;
  package.ReleaseAllObjects;
 Package.Destroy;
  if FileExists('../Textures/T_'+IntToStr(Amap+1)+'_'+IntToStr(Bmap)+'.utx') then begin
   package:= TUTPackage.Create;
    package.Initialize('../Textures/T_'+IntToStr(Amap+1)+'_'+IntToStr(Bmap)+'.utx');
    for n:=0 to package.ExportedCount-1 do begin
     if package.exported[n].UTObjectName=IntToStr(Amap+1)+'_'+IntToStr(Bmap)  then begin
      obj:=package.Exported[n].UTObject;
      obj.ReadObject;
       tex:=@obj;
    for i:= 0 to 255 do Land[256,i].h := (tex.Lan[0,i]/256) * 76 - Restit;
     end;
   end;
  package.ReleaseAllObjects;
 Package.Destroy;
  end;
  if FileExists('../Textures/T_'+IntToStr(Amap)+'_'+IntToStr(Bmap+1)+'.utx') then begin
   package:= TUTPackage.Create;
    package.Initialize('../Textures/T_'+IntToStr(Amap)+'_'+IntToStr(Bmap+1)+'.utx');
    for n:=0 to package.ExportedCount-1 do begin
     if package.exported[n].UTObjectName=IntToStr(Amap)+'_'+IntToStr(Bmap+1)  then begin
      obj:=package.Exported[n].UTObject;
      obj.ReadObject;
       tex:=@obj;
       for j:= 0 to 255 do Land[j,256].h := (tex.Lan[j,0]/256) * 76 - Restit;
     end;
   end;
  package.ReleaseAllObjects;
 Package.Destroy;
  end;
  if FileExists('../Textures/T_'+IntToStr(Amap+1)+'_'+IntToStr(Bmap+1)+'.utx') then begin
   package:= TUTPackage.Create;
    package.Initialize('../Textures/T_'+IntToStr(Amap+1)+'_'+IntToStr(Bmap+1)+'.utx');
    for n:=0 to package.ExportedCount-1 do begin
     if package.exported[n].UTObjectName=IntToStr(Amap+1)+'_'+IntToStr(Bmap+1)  then begin
      obj:=package.Exported[n].UTObject;
      obj.ReadObject;
      tex:=@obj;
      Land[256,256].h := (tex.Lan[0,0]/256) * 76 - Restit;
      end;
   end;
  package.ReleaseAllObjects;
 Package.Destroy;
  end;
Form1.StatusBar1.SimpleText:='Loading terrain...Done';
end;

procedure CalcArea(var Area: MTris);
var
  x,y,mi,ti,am,bm: Integer;
  mares: MTris;
begin
am:=(Amap-20)*32768;
bm:=(Bmap-18)*32768;
 setlength(Area.Tris,0);
  for  x:= 0 to 255 do begin
      for y := 0 to 255  do begin
  setlength(Area.Tris,length(Area.Tris)+2);
  Area.Tris[high(Area.Tris)-1].A:=D3DVector(am+x*128,bm+y*128,Land[x,y].h);
   Area.Tris[high(Area.Tris)-1].B:=D3DVector(am+(x+1)*128,bm+y*128,Land[x+1,y].h);
   Area.Tris[high(Area.Tris)-1].C:=D3DVector(am+(x+1)*128,bm+(y+1)*128,Land[x+1,y+1].h);
   Area.Tris[high(Area.Tris)-1].norm:=VectorCrossProduct(VectorSub(Area.Tris[high(Area.Tris)-1].B,Area.Tris[high(Area.Tris)-1].A),VectorSub(Area.Tris[high(Area.Tris)-1].C,Area.Tris[high(Area.Tris)-1].A));
  Area.Tris[high(Area.Tris)-1].norm:=VectorNormalize(Area.Tris[high(Area.Tris)-1].norm);
  Area.Tris[high(Area.Tris)-1].dist:=-VectorDotProduct(Area.Tris[high(Area.Tris)-1].norm,Area.Tris[high(Area.Tris)-1].A);
   Area.Tris[high(Area.Tris)].A:=D3DVector(am+x*128,bm+y*128,Land[x,y].h);
   Area.Tris[high(Area.Tris)].B:=D3DVector(am+(x+1)*128,bm+(y+1)*128,Land[x+1,y+1].h);
   Area.Tris[high(Area.Tris)].C:=D3DVector(am+x*128,bm+(y+1)*128,Land[x,y+1].h);
   Area.Tris[high(Area.Tris)].norm:=VectorCrossProduct(VectorSub(Area.Tris[high(Area.Tris)].B,Area.Tris[high(Area.Tris)].A),VectorSub(Area.Tris[high(Area.Tris)].C,Area.Tris[high(Area.Tris)].A));
  Area.Tris[high(Area.Tris)].norm:=VectorNormalize(Area.Tris[high(Area.Tris)].norm);
  Area.Tris[high(Area.Tris)].dist:=-VectorDotProduct(Area.Tris[high(Area.Tris)].norm,Area.Tris[high(Area.Tris)].A);
  end;
    Form1.ProgressBar1.Position:=100*x div 255;
  Form1.StatusBar1.SimpleText:='Generating terrain...'+IntToStr(round(100*x div 255))+'%';
 end;
{for mi:=0 to high(Brushes) do begin
  if Brushes[mi].csgoper=2 then begin
    setlength(mares.Tris,0);
    for ti:=0 to high(Area.Tris) do if TriIntersect(Area.Tris[ti],MT[ActorsCount-length(Brushes)+mi]) then PolySub(mares,Area.Tris[ti],MT[ActorsCount-length(Brushes)+mi]) else
    begin
    setlength(mares.Tris,length(mares.Tris)+1);
    mares.Tris[high(mares.Tris)]:=Area.Tris[ti];
    end;
    setlength(Area.Tris,0);
    Area:=mares;
    if length(Area.Tris)<10 then ShowMessage('Land was cutted by '+Brushes[mi].BrushName);
  end;
  Form1.ProgressBar1.Position:=100*mi div high(Brushes);
  Form1.StatusBar1.SimpleText:='Cutting terrain...'+IntToStr(round(100*mi div high(Brushes)))+'%';
end; }
end;

procedure CalcLand;
var
 x,y,ti: Integer;
 CurR: Ray;
 am,bm: Integer;
 dir,p: TD3DVector;
 CurT: Triangle;
 isf: boolean;
 cosang : single;
 dist: single;
 lambda: single;
 MinX,MinY,MaxX,MaxY,ai: single;
begin
am:=(Amap-20)*32768;
bm:=(Bmap-18)*32768;
Form1.ProgressBar1.Position:=0;
 for ti:=0 to high(Area.Tris) do begin
  CurT:=Area.Tris[ti];
   CurT.norm:=VectorCrossProduct(VectorSub(CurT.B,CurT.A),VectorSub(CurT.C,CurT.A));
   CurT.norm:=VectorNormalize(CurT.norm);
   CurT.dist:=-VectorDotProduct(CurT.norm,CurT.A);
  MinX:=CurT.A.X;
  MinY:=CurT.A.Y;
  MaxX:=CurT.A.X;
  MaxY:=CurT.A.Y;
 if MinX>CurT.B.X then begin MinX:=CurT.B.X end;
 if MinX>CurT.C.X then begin MinX:=CurT.C.X end;
 if MinY>CurT.B.Y then begin MinY:=CurT.B.Y end;
 if MinY>CurT.C.Y then begin MinY:=CurT.C.Y end;
 if MaxX<CurT.B.X then begin MaxX:=CurT.B.X end;
 if MaxX<CurT.C.X then begin MaxX:=CurT.C.X end;
 if MaxY<CurT.B.Y then begin MaxY:=CurT.B.Y end;
 if MaxY<CurT.C.Y then begin MaxY:=CurT.C.Y end;
 for y:=trunc(MinY/16) to trunc(MaxY/16) do begin
   for x:=trunc(MinX/16) to trunc(MaxX/16) do begin
    CurR.St:=D3DVector(x*16,y*16,16384);
    CurR.En:=D3DVector(x*16,y*16,-16384);
     dir:=VectorSub(CurR.En,CurR.St);
     isf:=true;
     cosang:=VectorDotProduct(dir,CurT.norm);
     if cosang>-EPSILON then if cosang<EPSILON then isf:=false;
     dist:= VectorDotProduct(CurR.St,CurT.norm);
     lambda:=(-CurT.dist-dist)/cosang;
     if lambda<0 then isf:=false;
     if lambda>1 then isf:=false;
     p:=VectorAdd(CurR.St,VectorMulS(dir,lambda));
     if CurT.norm.z>0 then begin
        ai:=(p.Y-CurT.A.Y)*(CurT.B.X-CurT.A.X)-(p.X-CurT.A.X)*(CurT.B.Y-CurT.A.Y);
        if ai<0 then isf:=false;
        ai:=(p.Y-CurT.B.Y)*(CurT.C.X-CurT.B.X)-(p.X-CurT.B.X)*(CurT.C.Y-CurT.B.Y);
        if ai<0 then isf:=false;
        ai:=(p.Y-CurT.C.Y)*(CurT.A.X-CurT.C.X)-(p.X-CurT.C.X)*(CurT.A.Y-CurT.C.Y);
        if ai<0 then isf:=false;
       end else begin
        ai:=(p.Y-CurT.A.Y)*(CurT.B.X-CurT.A.X)-(p.X-CurT.A.X)*(CurT.B.Y-CurT.A.Y);
        if ai>0 then isf:=false;
        ai:=(p.Y-CurT.B.Y)*(CurT.C.X-CurT.B.X)-(p.X-CurT.B.X)*(CurT.C.Y-CurT.B.Y);
        if ai>0 then isf:=false;
        ai:=(p.Y-CurT.C.Y)*(CurT.A.X-CurT.C.X)-(p.X-CurT.C.X)*(CurT.A.Y-CurT.C.Y);
        if ai>0 then isf:=false;
       end;
    if isf=false then continue;
    if ((x-am div 16)>=0) and ((x-am div 16)<=2047) and ((y-bm div 16)>=0) and ((y-bm div 16)<=2047) then begin
    if length(GDL[x-am div 16,y-bm div 16])=0 then begin
    setlength(GDL[x-am div 16,y-bm div 16],1);
    GDL[x-am div 16,y-bm div 16,0]:= round (p.Z);
    end;
   end;
  end;
 end;
  Form1.ProgressBar1.Position:=100*ti div high(Area.Tris);
  Form1.StatusBar1.SimpleText:='Calculating terrain...'+IntToStr(round(100*ti div high(Area.Tris)))+'%';
end;
 Form1.StatusBar1.SimpleText:='Calculating terrain...Done';
end;

procedure OptimizeNode(x,y: Integer);
var
i,h,t,n : integer;
begin
 if length(GDU[x,y])=1 then exit;
 for i:=0 to high(GDU[x,y]) do begin
   for h:=0 to length(GDU[x,y])-1 do
   for n:=h to length(GDU[x,y])-1 do begin
    if GDU[x,y,h]<GDU[x,y,n] then begin
    t:=GDU[x,y,n];
    GDU[x,y,n]:=GDU[x,y,h];
    GDU[x,y,h]:=t;
    end;
  end;
 end;
 h:=0;
  while h<length(GDU[x,y])-1 do begin
   if (GDU[x,y,h]-GDU[x,y,h+1])<24 then begin
    for n:=h+1 to high(GDU[x,y]) do GDU[x,y,n]:=GDU[x,y,n+1];
    h:=h-1;
    setlength(GDU[x,y],length(GDU[x,y])-1);
   end;
   h:=h+1;
  end;
end;
end.
